--region UpZdlLayer.lua
--Author : fco
--Date   : 2014-9-11
--此文件由[BabeLua]插件自动生成
require("luaScript/apiRequest")
require("luaScript/smartRes")
require("luaScript/CalcHurm")
require("luaScript/noticeMsg")

local zdllayer=nil;
local m_s=CCSize(500,550);
local mZorder={-2147483648,-100,0,1,2,3,4,5,10000};-- 1~9
local winSize=nil;
local fx=0;
local fy=0;
local iOpenid=-1;
--定义全局json
local m_stFightNumConf=nil;
local m_stMobileConf=nil;
local m_stPet=nil;
local m_stUseAttr=nil;


--定义表结构
local m_mapZdls={};
local m_stEq={};

--坐标
local m_pZdl=nil;
local m_pTarget=nil;
local m_pZdlUp=nil;

--CuseData.cpp传递过来的json
local m_stquest={};


function BtnCallback_close()
    zdllayer:removeFromParentAndCleanup(true);
end
function TouchCallback_handler(event,x,y)
    --print("touch pos x:"..x.."y:"..y);

    return true;
end
function runlayer(curquest)
    --print("upzdl layer");
    m_stquest=JSON:decode(curquest);

    zdllayer=CCLayer:create();
    CCDirector:sharedDirector():getRunningScene():addChild(zdllayer,mZorder[9]);
    
    local pshandow=CCLayerColor :create(ccc4(0,0,0,190));
    zdllayer:addChild(pshandow,mZorder[2]);

    local pbg=CCScale9Sprite:create(CCRectMake(65,57,13,22),"common/commBox.png");
    local offsety=-20;
    pbg:setPreferredSize(m_s);
    
    winSize = CCDirector:sharedDirector():getWinSize();
    pbg:setPosition(ccp(winSize.width/2,winSize.height/2+offsety));
    zdllayer:addChild(pbg,mZorder[3]);

    fx,fy=0,0;
    --左上角
    local ptopleft=CCSprite:create("common/topLeft.png");
    --print(posXof(pbg));
    ptopleft:setPosition(ccp(posXof(pbg)-m_s.width/2+widthOf(ptopleft)/2+fx,
    posYof(pbg)+m_s.height/2-heightOf(ptopleft)/2+fy));
    zdllayer:addChild(ptopleft);

    --关闭按钮
    local pclose=CCMenuItemImage:create("common/btn_style_12.png","common/btn_style_12_s.png");
    pclose:registerScriptTapHandler(BtnCallback_close);
    pclose:setPosition(ccp(posXof(pbg)+m_s.width/2-widthOf(pclose)/2+6,posYof(pbg)+m_s.height/2 - heightOf(pclose)/2+6));

    local pMenu= CCMenu:create();
    pMenu:setPosition(ccp(0,0));
    pMenu:addChild(pclose);
    pMenu:setTouchPriority(mZorder[1]+97);

    zdllayer:addChild(pMenu);

    ------------------------------------------*****************数据初始化*****************---------------------------------------------
    m_stFightNumConf=getConf("config/combatpower_config.txt")["fightnum"];
    m_stMobileConf=getConf("config/mobileConf.txt")["FightFail"];
    m_stUseAttr=getUserInfo("attr");
    
	m_mapZdls[m_stMobileConf["petlv"]["type"]]={};
    m_mapZdls[m_stMobileConf["petlv"]["type"]]["zdl"]=0;
	m_mapZdls[m_stMobileConf["equiplv"]["type"]]={};
    m_mapZdls[m_stMobileConf["equiplv"]["type"]]["zdl"]=0;
	m_mapZdls[m_stMobileConf["gemlv"]["type"]]={};
    m_mapZdls[m_stMobileConf["gemlv"]["type"]]["zdl"]=0;
	m_mapZdls[m_stMobileConf["winglv"]["type"]]={};
    m_mapZdls[m_stMobileConf["winglv"]["type"]]["zdl"]=0;

    print("***********info:"..JSON:encode(getUserInfo("attr")));
	m_stPet=getUserInfo("map")["pet"];
    print("#########time begin "..os.clock());

	if(m_stPet["growpet"])then
	    local i=0;
			for idx,var in pairs(m_stPet["growpet"])do
				--宠物信息
				m_stEq[i]=GetPetZdl(var,m_stUseAttr["level"],m_stPet["wing"]);
                print(JSON:encode(m_stEq[i]));
				m_mapZdls[m_stMobileConf["petlv"]["type"]]["zdl"]=m_mapZdls[m_stMobileConf["petlv"]["type"]]["zdl"]+(m_stEq[i]["lv_add"]["sum"] or 0)+(m_stEq[i]["hero_add"]["sum"] or 0);
				if(m_stEq[i]["grade_add"])then
				    m_mapZdls[m_stMobileConf["petlv"]["type"]]["zdl"]=m_mapZdls[m_stMobileConf["petlv"]["type"]]["zdl"]+(m_stEq[i]["grade_add"]["sum"] or 0);
                end
				-- 装备战斗力
				if(m_stEq[i]["eq"])then
					for idxeq,vareq in pairs(m_stEq[i]["eq"])do
						m_mapZdls[m_stMobileConf["equiplv"]["type"]]["zdl"]=m_mapZdls[m_stMobileConf["equiplv"]["type"]]["zdl"]+(vareq["power_add"]["sum"] or 0);
					end
				end
				--宝石战力
				if m_stEq[i]["gem_add"]then
					m_mapZdls[m_stMobileConf["gemlv"]["type"]]["zdl"]=m_mapZdls[m_stMobileConf["gemlv"]["type"]]["zdl"]+(m_stEq[i]["gem_add"]["sum"] or 0);
				end
				--翅膀增加的战斗力
				if m_stEq[i]["wing_add"]then
					m_mapZdls[m_stMobileConf["winglv"]["type"]]["zdl"]=m_mapZdls[m_stMobileConf["winglv"]["type"]]["zdl"]+ (m_stEq[i]["wing_add"]["sum"] or 0);
				end

                i=i+1;
			end
		end
		
		print("m_stEq------------"..JSON:encode(m_stEq));
		print("m_mapZdls------------"..JSON:encode(m_mapZdls));
	------------------------------------------************数据初始化*****************-----------------------------------------
   
		m_pZdl=ccp(96,20);
		m_pTarget=ccp(53,64);
		m_pZdlUp=ccp(25,30);
		local pScrollLayer=CCLayer:create();

		local pScrollView=CCScrollView:create();
		pScrollView:setTouchEnabled(true);
		pScrollView:setDirection(kCCScrollViewDirectionVertical);
		pScrollView:setAnchorPoint(ccp(0.5,1));
		fx,fy=0,0;
		pbg:addChild(pScrollView);

		local pMenu=CCMenu:create();
		pMenu:setPosition(ccp(0,0));
		pScrollLayer:addChild(pMenu);
		local i,width,height,iCount=0,0,0,0;
        local iH=0;--总数,行数
		for idx,var in pairs(m_stMobileConf) do
			if(var["type"] and var["visible"]==1)then
				iCount=iCount+1;
			end
		end
		iH=math.floor(iCount/2);
		if(iCount%2~=0)then
			iH=iH+1;
		end
		local itemx,itemy=0,0;
        
        --print("mobile conf:"..JSON:encode(m_stMobileConf));
		for idx,var in pairs(m_stMobileConf) do
            --print("add item begin;"..JSON:encode(var));
			if(var["type"] and var["visible"]==1)then

				local pNode=getZdlByType(var["type"]);
                --print(pNode);
				if(pNode)then 
				    i=i+1;
				    if(width==0)then
					    width=widthOf(pNode);
					    height=heightOf(pNode);
					    itemx=width/2;
					    itemy=iH*height-height/2;
				    end
				    pNode:setPosition(ccp(itemx,itemy));
                    --print("iOpenid:"..iOpenid);
				    pMenu:addChild(pNode);
				    pNode:setTag(iOpenid);
				    itemx=itemx+width;
				    if(i%2==0)then
					    itemy=itemy-height;
					    itemx=width/2;
				    end
                end
			end
		end
	    print("#########time end "..os.clock());
        --print("iH"..iH);
		local containSize=CCSize(width*2,iH*height);
		pScrollLayer:setContentSize(containSize);
		pScrollView:setContainer(pScrollLayer);
		pScrollView:setViewSize(CCSize(containSize.width,2*height));
		fy=30;
		pScrollView:setPosition(widthOf(pbg)/2-containSize.width/2,fy);
		pScrollView:setTouchPriority(mZorder[1]+98);
		pMenu:setTouchPriority(mZorder[1]+98);
    
        zdllayer:registerScriptTouchHandler(TouchCallback_handler,false,mZorder[1]+99,true);
        zdllayer:setTouchEnabled(true);


end

function m_stGetFight(gtype,targetlv)
	iOpenid=-1;
	local stRet={};
	    for idx,var in pairs(m_stFightNumConf) do
		    if(nil~=var["type"] and nil~=var["level"]) then
			    if(var["type"]==gtype and var["level"]==targetlv) then
				    stRet=var;
				    iOpenid=var["button"];
				    break;
			    end
		    end
	    end
	return stRet;	
end
--装备强化,装备宝石镶嵌,宠物,装备洗练
function getZdlByType(itype)
	local pRet=nil;
    repeat
	    local ilv=getNextLv(itype);
	    if(ilv==-1) then 
            break;
        end 

        --print("itype "..itype.." ilv "..ilv);

	    local stTmp=m_stGetFight(itype,ilv);
	    if(getUserInfo("attr")["level"]<stTmp["openlevel"])then
            break;
        end
	    if(not checkOpen())then
            break;
        end
	    if(stTmp==nil)then
            break;
        end
	    pRet=CCMenuItemImage:create("fail/item_bg1.png","");
        pRet:registerScriptTapHandler(BtnCallback_goto);

	    local pPzdl=CCLabelBMFont:create(tostring(m_mapZdls[itype]["zdl"]),"fonts/item_num_red.fnt");
	    pPzdl:setAnchorPoint(ccp(0,0.5));
	    pPzdl:setPosition(ccp(widthOf(pRet)-m_pZdl.x,heightOf(pRet)-m_pZdl.y));
	    pRet:addChild(pPzdl);

	    local pTarget=CCLabelTTF:create(tostring(stTmp["des"]),MWLL_FONT_NAME,18);
	    pTarget:setColor(strToColor("3f0000"));
	    pTarget:setAnchorPoint(ccp(0,0.5));
	    pTarget:setPosition(m_pTarget);
	    pRet:addChild(pTarget);

	    local pImg=CCSprite:create(string.format("fail/img_%d.png",itype));
	    fy=140;
	    pImg:setPosition(ccp(widthOf(pRet)/2,fy));
	    pRet:addChild(pImg);

	    local pUpL=CCLabelTTF:create("战斗力可提升：",MWLL_FONT_NAME,18);
	    pUpL:setColor(strToColor("fff9c2"));
	    pUpL:setAnchorPoint(ccp(0,0.5));
	    pUpL:setPosition(m_pZdlUp);
	    pRet:addChild(pUpL);

	    local pUpR=CCLabelTTF:create(tostring(m_mapZdls[itype]["up"]),MWLL_FONT_NAME,20);
	    pUpR:setColor(strToColor("88FE01"));
        pUpR:setAnchorPoint(ccp(0,0.5));
	    pUpR:setPosition(ccp(m_pZdlUp.x+widthOf(pUpL)-7,m_pZdlUp.y));
	    pRet:addChild(pUpR);

        do break end;
    until nil;

	return pRet;
end
function BtnCallback_goto(tag,sender)
	if(tag~=-1) then
		CCNotificationCenter:sharedNotificationCenter():postNotification(noticeMsg.MSG_CLOSE_PVE,nil);
		CCNotificationCenter:sharedNotificationCenter():postNotification(noticeMsg.MSG_OPEN_FUNC_BY_ID,tolua.cast(CCString:create(tag),"CCObject"));
		zdllayer:removeFromParentAndCleanup(true);
	end
end
function getNextLv(itype,minlv)
	m_mapZdls[itype]["up"]=0;
    for idx,var in pairs(m_stFightNumConf)do
		if var["type"] and var["targetlevel"] then
			if(var["type"]==itype)then
				local sumzdl=0;
				for idxs,vars in pairs(var["singlenum"])do
					sumzdl= sumzdl+vars;
				end
				if(sumzdl>m_mapZdls[itype]["zdl"])then
					m_mapZdls[itype]["up"]=sumzdl-m_mapZdls[itype]["zdl"];
					return var["level"];
				end

			end
		end
	end
	return -1;
end
function checkOpen()
	local bRet=false;
    repeat
		local finishQuest = getOrderPreQuestsById(getCurMainQuestId(m_stquest));
		--finishQuest.push_back(getCurMainQuestId());
        local finishQuestCount=table.getn(finishQuest)-1;

		local pMapConf = getConf("config/gamehall_config.txt");
        local idxq;
        local varq;
		for idx,var in pairs(pMapConf)do
            idxq=idx;
            varq=var;
			if(iOpenid==var["id"])then
				break;
			end
		end
        --print("idxq"..idxq)
		if(idxq==finishQuestCount)then
            break;
        end

        -- print("varq"..JSON:encode(varq));
        local attr = getUserInfo("attr");
        if(attr["level"] >= varq["lv"]) then
            if(varq["QuestId"]==0)then
                bRet=true;
            else
                for i = 1,table.getn(finishQuest)do
                
                    if(finishQuest[i] == varq["QuestId"])then
                        bRet=true;
                        break;
                    end
                end
            end
        end
        do break end
	until nil;

    --print("checkOpen back "..tostring(bRet));
	return bRet;
end


--endregion
