--region Utils.lua
--Author : jax
--Date   : 2014/9/22
--此文件由[BabeLua]插件自动生成
require("luaScript/apiRequest")

function getDescId(id)
    local goodsConf = getConf("config/mobile_goods_cfg.txt");
    if(goodsConf[tostring(id)])then
        local gid = goodsConf[tostring(id)]["subid"];
        return gid;
    end
end
--endregion
function spiltArray(str,pattern)
    local retArray = {};
    local patSize = string.len(pattern);
    while string.len(str)>0 
    do
        local pos = string.find(str, pattern,1,true);
        if(pos)then
            retArray[#retArray+1] = string.sub(str, 1, pos-1);
            str = string.sub(str, pos+patSize);
        else
            retArray[#retArray] = str;
            str="";
        end
    end;

    return retArray;
--    print("spilt array");
--    logJson(retArray);
end

function createArmatureLua(jsonfile,name,plist)
    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo(jsonfile);
    if(plist)then
        CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile(plist);
    end
    local bgArma = CCArmature:create(name);
    return bgArma;
end

function createMwllAnimation(plistName,headStr,beginIdx,num,inv)
    local Ani = CCAnimation:create();
    local cache = CCSpriteFrameCache:sharedSpriteFrameCache();
    cache:addSpriteFramesWithFile(plistName);
    for i = beginIdx,beginIdx+num-1 do            
        local imgName = string.format("%s%d.png",headStr,i);
        --print("create imgName -"..imgName);
        local imgSp = cache:spriteFrameByName(imgName);
        Ani:addSpriteFrame(imgSp);
    end
    Ani:setDelayPerUnit(inv);
    return Ani;
end

function createRoleWithWing(sex,wLv,fScale,bWing,flipX)
    --print(sex..","..wLv);

	local pRet=CCNode:create();
    pRet:setAnchorPoint(ccp(0,0));
	local s=CCSize(317*fScale,498*fScale);
	pRet:setContentSize(s);
	local ctmp=string.format("wings/userwing_%d.png",wLv);
	local pw=nil;
	if wLv>1 and wLv<11 then
        pw=CCSprite:create(ctmp);
    end
	if(pw)then
		pw:setPosition(ccp(-s.width*9/110+((flipX and 18) or 0),-s.height*4/17));

        print("x="..(s.width*9/22+((flipX and 18) or 0))..";y="..(s.height*4/15));
		pw:setScale(fScale*2.5);
	    pw:setFlipX(flipX);
		pRet:addChild(pw);
	end
		
	if(sex~=1 and sex~=2)then
		sex=1;
	end
	local ps=string.format("new_quest/new_npc0_0%d.png",sex);
	local pPerson=CCSprite:create(ps);
	pPerson:setFlipX(flipX);
	pPerson:setScale(fScale);
	pPerson:setPosition(ccp(0,0));
	pRet:addChild(pPerson);
	return pRet;
end