--region apiRequest.lua
--Author : jax
--Date   : 2014/8/28
--此文件由[BabeLua]插件自动生成

--JSON = (loadfile "luaScript/JSON.lua")();
require("luaScript/JSON");
JSON = OBJDEF:new();
mwll_conf = {};
MWLL_FONT_NAME = "fonts/DFPYuanW7-GB.ttf"
function luaApiRequest(req,callback)
    local reqStr = "";
    if(not req["cmd"])then return end
        
    for key,var in pairs(req) do
        reqStr = reqStr..key.."="..var.."&"
    end
    reqStr = string.sub(reqStr, 1, -2);
    CUserData:getInstance():ApiRequestForLua(req["cmd"],reqStr,callback);
end

--些函数可以传 attr map goods pet msg quest eq friend 等等
function getUserInfo(str)
   -- JSON = (loadfile "luaScript/JSON.lua")();
    local jsonStr = CUserData:getInstance():getUserDataJsonStr(str);
    local jsonVar = JSON:decode(jsonStr);
    return jsonVar;
end

function logJson(jsonvar)
    
    local jsonstr = JSON:encode(jsonvar);
    print(jsonstr); 
end


function getConf(cfgName)
   -- CCFileUtils:fullPathForFilename()
   if(mwll_conf[cfgName])then
        return mwll_conf[cfgName];
    end

    local ccConf = CCString:createWithContentsOfFile(cfgName);
    local str = ccConf:getCString();

   -- local retName = cfgName;
   -- while(true) do
   --     local i,j = string.find(retName, "/");
   --     if(i)then
   --         retName = string.sub(retName,j+1,-1);
   --     else
   --         break;
   --     end
            
   -- end
    
   ----CCFileUtils:getWritablePath()
   --local filefullName =  CCFileUtils:sharedFileUtils():getWritablePath()..retName;
   --print("file name is ",filefullName);
   --local f = io.open(filefullName, "r");
   --local str = f:read("*all");


   local conf = JSON:decode(str);
 --  f:close();
   mwll_conf[cfgName] = conf;
   return conf;
end


function getPreQuestById(id)
	local questConf = getConf("config/main_quest2.txt");
	for idx,var in ipairs(questConf["quest"])do
		if (id==var["id"] and var["type"] == 1)then
			return var["front"][1];
		end
	end
	
	return nil;
end

function getOrderPreQuestsById(id)
	local preId = 0;
	local curId = id;
	local Ids={};
    local i=1;
	repeat
		preId = getPreQuestById(curId);
		if (preId) then
			Ids[i]=preId;
		end
		curId = preId;
        i=i+1;
	until curId==nil;
	return Ids;
end

function getCurMainQuestId(m_stQuest)
	local questConf = getConf("config/main_quest2.txt");
    print("questConf:"..JSON:encode(questConf));
    print("m_stQuest:"..JSON:encode(m_stQuest));

	for idxi,vari in ipairs(m_stQuest)do --i
		for idxj,varj in ipairs(questConf["quest"])do--j
			if (vari["id"]==varj["id"] and varj["type"] == 1)then
				return vari["id"];
			end
		end
	end
	return nil;
end
--endregion
