--region petFightLayer.lua
--Author : jax
--Date   : 2014/8/29
--此文件由[BabeLua]插件自动生成
require("luaScript/apiRequest")
require("luaScript/smartRes")
require("luaScript/noticeMsg")
require("luaScript/CalcHurm")
require("luaScript/mwllMusic");
require("luaScript/Utils.lua");
require("luaScript/AnimateUtils.lua");

PET_SK = 
{
    NO_SK =0,
    SINGLE = 1,
    FIRST_ROW = 2,
    COLUMN = 3,
    RANDOM_3 =4,
    SECOND_ROW=5,
    THIRD_ROW = 6,
    ALL =7,
    SINGLE_ADD =8,
    ALL_ADD =9,

    PET_SK_22=22,
    PET_SK_23=23,
    PET_SK_24=24,
    PET_SK_25=25,  
    PET_SK_26=26,  
    PET_SK_27=27,
    PET_SK_28=28,
    PET_SK_29=29,
    PET_SK_30=30,
    PET_SK_31=31,  
    PET_SK_32=32,
    PET_SK_33=33,
    PET_SK_34=34,
    PET_SK_35=35,  
    PET_SK_36=36,  
    PET_SK_37=37,
    PET_SK_38=38,
    PET_SK_39=39,
    PET_SK_40=40,
    PET_SK_41=41,  
    PET_SK_42=42,
    PET_SK_43=43,
    PET_SK_44=44,
    PET_SK_44=44,
    PET_SK_45=45,
    PET_SK_46=46
}

local lastSkPos;

local parentLayer = nil;
local luaCallBack = nil;
local fightLayer = nil;
local petLayer = nil;
local bgLayer = nil;
local winSize = nil;
local myPet = nil;
local enemyPet = nil;

local pPetInCage = nil;

local ragePerAtk = getConf("config/mobileConf.txt")["pet_atk"]["rageatk"];
local rangBeAtk = getConf("config/mobileConf.txt")["pet_atk"]["ragebeatk"];
local rageSum = getConf("config/mobileConf.txt")["pet_atk"]["ragesum"];

local petScaleConf = getConf("config/mobileConf.txt")["petScaleConf"] or 1.5;

local myMul = 1.0;
local enemyMul = 1.0;

local myAttr;
local myMap;
local petAniConf;
local petPosConf;
local mid;

local enemyAttr;
local enemyMap;

local gameResult;

local DialogId;

local petStats = nil;

local curStep =0;
local m_ActionList=nil;

local petConf = nil;

local xPetCnt =3;
local yPetCnt =2;

local step_intrvl = 0.5--每一步骤间的时间间隔
local speedRate = 1;--1正常，0.5表示正常速率时间的0.5倍数

local speedStat = nil;--当前加速状态
local btnSpeed = nil;--CCMenuItemToggle

local int_min=-2147483648;--设置触摸优先级
local function closeBtn()
    fightLayer:removeFromParentAndCleanup(true);
   
    CCSpriteFrameCache:sharedSpriteFrameCache():removeUnusedSpriteFrames();
	--CCTextureCache:sharedTextureCache():removeUnusedTextures();
    local res;
    local resStr;
    if(gameResult)then
        resStr = "win";
        res= CCString:create("win");
    else
        resStr = "lose";
        res= CCString:create("lose");
    end
     playBGM(BG_MUSIC.MW_MUSIC_MAIN_BGM);
     if(luaCallBack)then
        luaCallBack(resStr);
    else
        CCNotificationCenter:sharedNotificationCenter():postNotification(noticeMsg.MSG_PET_FIGHT_END,res);
    end
end

local function getPetConfById(petid)
    return petConf["info"][tostring(petid)];
end

local function getColorById(id)
    local c = getPetConfById(id);
    local q
    if(c)then
     q = c["q"];
    else
     q = 2;
    end

    local color;
    if(q==2) then
        color = strToColor("66ff66");
    elseif(q==3) then
        color = strToColor("33ccff");
    elseif(q==4) then
        color = strToColor("cc66ff");
    elseif(q==5) then
        color = strToColor("ffff00");
    elseif(q==6) then
        color = strToColor("ff9900");
    else
        color = strToColor("ffffff");
    end;
    return color;
end

local function getPosOfEventAndPos(event,pos)
    local retPos ={};
    



    return retPos;
end

local function showGameResult()
    local animation = CCAnimation:create();

    local head ="";
    local y;
    if(gameResult)then
        head = "game_win_";
        playEffect(EFFECT_MUSIC.MW_LINK_WIN);   
        y=0;
    else
        head = "game_lost_"
        playEffect(EFFECT_MUSIC.MW_LINK_LOSE);
        y=150;
    end
        
    local  name;
    for i = 1, 9 do
        name = head..i..".png";
        local spf = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(name);
        if(not spf)then
            print("error sp ",name);
            break;
        end
        animation:addSpriteFrame(spf);
    end

    animation:setDelayPerUnit(0.1*speedRate);
    local aniaction = CCAnimate:create(animation);

    local resImg = CCSprite:create();
    petLayer:addChild(resImg,10);
    resImg:setPosition(ccp(gCenterX,gCenterY+y));

    local array = CCArray:create();
    array:addObject(aniaction);
    array:addObject(CCDelayTime:create(0.5*speedRate));
    array:addObject(CCCallFunc:create(function() resImg:removeFromParentAndCleanup(true); end));
    array:addObject(CCCallFunc:create(showAfterDialog));
    

    local action = CCSequence:create(array);
    resImg:runAction(action);
    
end

local function fightLayerOnTouch(envent,x,y)
    print(string.format("x:%f,y%f",x,y));
    return true;
end



local function getPetBlood(petInfo)
--后面加上算血的东西
    local zdl = GetPetZdl(petInfo,myAttr["level"],myMap["pet"]["wing"]);
--    print("pet no:",petInfo["no"]);
--    logJson(zdl);
    return zdl["zdl"]["hp"];
end

local function getPetAtk(petAtk,petDef,atklv,deflv,atkWing,defWing,mul)
--后面加上计算公式

    local bld = CalcHurm(petAtk, petDef,atklv,deflv,atkWing,defWing) * mul;
--    bld =60;
    print("bld is ",bld,"mul is ",mul);
    --logJson(petAtk);
    --logJson(petDef);
    return math.floor(bld);
end

local function getPetHeal(petHeal,petBeHead,atkWing,defWing,mul)
    local zdl = GetPetZdl(petBeHead,myAttr["level"],defWing);
    return zdl["zdl"]["hp"]*mul;
end



local function getAtkAndBld(sk,atkPet,atkpets,defpets,bLeft) 

    local petRet;
    local pos_add=0;
    if(bLeft)then
        pos_add = xPetCnt*yPetCnt;
    end
    if(sk==PET_SK.NO_SK or sk==PET_SK.SINGLE or sk ==PET_SK.PET_SK_23 or sk ==PET_SK.PET_SK_27 or sk ==PET_SK.PET_SK_31 or sk ==PET_SK.PET_SK_35 or sk ==PET_SK.PET_SK_39 or sk ==PET_SK.PET_SK_43)then
        local cy = atkPet["pos"]%yPetCnt;
        local yList = {};
        yList[#yList+1] = cy;
        for i=0,yPetCnt-1 do
            if(i~=cy)then
                    yList[#yList+1] = i;
                end
        end
        local oneDef;
        for k,i in ipairs(yList) do
            local ii = i%yPetCnt;
            for j = ii,ii+xPetCnt*yPetCnt-1,yPetCnt do
                    local jj = j;
                    for k,var in ipairs(defpets) do
                    if(var["pos"]==jj and var["bld_cur"]>0)then
                        oneDef = var;
                        break;
                    end
                    end
                if(oneDef)then  break end;
            end
            if(oneDef)then break end;               
        end
        if(oneDef)then
            local bld ;
            if(bLeft)then
                bld = - getPetAtk(atkPet,oneDef,myAttr["level"],enemyAttr["level"],myMap["pet"]["wing"],nil,myMul);
            else
                bld = - getPetAtk(atkPet,oneDef,enemyAttr["level"],myAttr["level"],nil,myMap["pet"]["wing"],enemyMul);
            end
            if(sk~=PET_SK.NO_SK)then
                bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
            end
            oneDef["bld_cur"] = oneDef["bld_cur"]+bld;

            petRet = {};
            petRet[1] = {["pos"]=oneDef["pos"]+pos_add,["bld_add"] = bld};

        end


    elseif(sk==PET_SK.FIRST_ROW or sk==PET_SK.SECOND_ROW or sk==PET_SK.THIRD_ROW or sk ==PET_SK.PET_SK_22 or sk ==PET_SK.PET_SK_26 or sk ==PET_SK.PET_SK_30 or sk ==PET_SK.PET_SK_34 or sk ==PET_SK.PET_SK_38 or sk ==PET_SK.PET_SK_42)then
        local xList = {};
        local firstList = 0;
        if(sk==PET_SK.SECOND_ROW) then
            firstList =1;
        elseif(sk==PET_SK.THIRD_ROW) then
            firstList =2;
        end

        xList[#xList+1] = firstList;
        for tx =0,xPetCnt-1 do
            if(tx~=firstList) then
                xList[#xList+1] = tx;
            end
        end

        local tarX;
        for i,tx in ipairs(xList) do
            for ty=0,yPetCnt-1 do
                local tpos = tx *yPetCnt+ty;
                for k,var in ipairs(defpets) do
                    if(var["pos"]==tpos and var["bld_cur"]>0)then
                        tarX = tx;
                        break;
                    end
                end
                if(tarX) then break end

            end
            if(tarX) then break end
        end
        if(tarX) then
            petRet = {};
            for ty=0,yPetCnt-1 do
                local tpos = tarX *yPetCnt+ty;
                for k,var in ipairs(defpets) do
                    if(var["pos"]==tpos and var["bld_cur"]>0)then
                        local bld ;
                        if(bLeft)then
                            bld = - getPetAtk(atkPet,var,myAttr["level"],enemyAttr["level"],myMap["pet"]["wing"],nil,myMul);
                        else
                            bld = - getPetAtk(atkPet,var,enemyAttr["level"],myAttr["level"],nil,myMap["pet"]["wing"],enemyMul);
                        end
                        bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
                        var["bld_cur"] = var["bld_cur"]+bld;
                        petRet[#petRet + 1] = {["pos"]=var["pos"]+pos_add,["bld_add"] = bld};
                    end
                end
                
            end

        end
    elseif(sk==PET_SK.COLUMN or sk ==PET_SK.PET_SK_25 or sk ==PET_SK.PET_SK_29 or sk ==PET_SK.PET_SK_33 or sk ==PET_SK.PET_SK_37 or sk ==PET_SK.PET_SK_41 or sk ==PET_SK.PET_SK_45)then
        local cy = atkPet["pos"]%yPetCnt;
        local yList = {};
        yList[#yList+1] = cy;
        for i=0,yPetCnt-1 do
            if(i~=cy)then
                    yList[#yList+1] = i;
                end
        end
        local tarY;
        for k,i in ipairs(yList) do
            local ii = i%yPetCnt;
            for j = ii,ii+xPetCnt*yPetCnt-1,yPetCnt do
                    local jj = j;
                    for k,var in ipairs(defpets) do
                    if(var["pos"]==jj and var["bld_cur"]>0)then
                        tarY = ii;
                        break;
                    end
                    end
                if(tarY)then  break end;
            end
            if(tarY)then break end;               
        end
        if(tarY)then
            petRet = {};
            for tx=0,xPetCnt-1 do
                local tpos = tx*yPetCnt+tarY;
                for k,var in ipairs(defpets) do
                    if(var["pos"]==tpos and var["bld_cur"]>0)then
                        local bld ;
                        if(bLeft)then
                            bld = - getPetAtk(atkPet,var,myAttr["level"],enemyAttr["level"],myMap["pet"]["wing"],nil,myMul);
                        else
                            bld = - getPetAtk(atkPet,var,enemyAttr["level"],myAttr["level"],nil,myMap["pet"]["wing"],enemyMul);
                        end
                        bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
                        var["bld_cur"] = var["bld_cur"]+bld;
                        petRet[#petRet + 1] = {["pos"]=var["pos"]+pos_add,["bld_add"] = bld};
                    end
                end

            end


        end

    elseif(sk==PET_SK.RANDOM_3)then
        local poslist = {};
        for k,var in ipairs(defpets) do
            if(var["bld_cur"]>0)then
                poslist[#poslist+1] = var["pos"];
            end
        end

        if(#poslist>0) then
            petRet = {};
            for i=1,3 do
                if(#poslist<=0) then break end;

                local idx = math.random(1,#poslist);
                local tpos  = poslist[idx];
                table.remove(poslist,idx);

                for k,var in ipairs(defpets) do
                    if(var["pos"]==tpos and var["bld_cur"]>0)then
                        local bld ;
                        if(bLeft)then
                            bld = - getPetAtk(atkPet,var,myAttr["level"],enemyAttr["level"],myMap["pet"]["wing"],nil,myMul);
                        else
                            bld = - getPetAtk(atkPet,var,enemyAttr["level"],myAttr["level"],nil,myMap["pet"]["wing"],enemyMul);
                        end
                        bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
                        var["bld_cur"] = var["bld_cur"]+bld;
                        petRet[#petRet + 1] = {["pos"]=var["pos"]+pos_add,["bld_add"] = bld};
                    end
                end

            end

        end
    elseif(sk==PET_SK.ALL or sk ==PET_SK.PET_SK_24 or sk ==PET_SK.PET_SK_28 or sk ==PET_SK.PET_SK_32 or sk ==PET_SK.PET_SK_36 or sk ==PET_SK.PET_SK_40 or sk ==PET_SK.PET_SK_44)then
        for k,var in ipairs(defpets) do
            if(var["bld_cur"]>0)then
                local bld ;
                if(bLeft)then
                    bld = - getPetAtk(atkPet,var,myAttr["level"],enemyAttr["level"],myMap["pet"]["wing"],nil,myMul);
                else
                    bld = - getPetAtk(atkPet,var,enemyAttr["level"],myAttr["level"],nil,myMap["pet"]["wing"],enemyMul);
                end
                bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
                var["bld_cur"] = var["bld_cur"]+bld;
                if (not petRet)then 
                    petRet ={};
                end
                petRet[#petRet + 1] = {["pos"]=var["pos"]+pos_add,["bld_add"] = bld};
            end
        end

    elseif(sk==PET_SK.SINGLE_ADD or sk ==PET_SK.PET_SK_46)then
        local petMinBld;
        for k,var in ipairs(atkpets) do
            if(var["bld_cur"]>0)then
                if(not petMinBld) then
                    petMinBld = var;
                elseif(var["bld_cur"]<petMinBld["bld_cur"])then
                    petMinBld = var;
                end
            end
        end
        local bld ;
        local p;
        if(bLeft)then
            bld = getPetHeal(atkPet,petMinBld,myMap["pet"]["wing"],nil,myMul);
            p = 0;
        else
            bld = getPetHeal(atkPet,petMinBld,nil,myMap["pet"]["wing"],enemyMul);
            p = xPetCnt*yPetCnt;
        end
        bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
        petMinBld["bld_cur"] = petMinBld["bld_cur"]+bld;
        if (not petRet)then 
            petRet ={};
        end
        petRet[#petRet + 1] = {["pos"]=petMinBld["pos"]+p,["bld_add"] = bld};

--    elseif(sk==PET_SK.ALL_ADD)then
      else
         for k,var in ipairs(atkpets) do
            if(var["bld_cur"]>0)then
                local bld ;
                local p;
                if(bLeft)then
                    bld =  getPetHeal(atkPet,var,myMap["pet"]["wing"],nil,myMul);
                    p = 0;
                else
                    bld =  getPetHeal(atkPet,var,nil,myMap["pet"]["wing"],enemyMul);
                    p = xPetCnt*yPetCnt;
                end
                bld = math.floor(bld * (petConf["info"][tostring(atkPet["id"])]["rank"] or 100) /100);
                var["bld_cur"] = var["bld_cur"]+bld;
                if (not petRet)then 
                    petRet ={};
                end
                petRet[#petRet + 1] = {["pos"]=var["pos"]+p,["bld_add"] = bld};
            end
        end
    end
    if(petRet) then
        for k,var in ipairs(petRet) do
            var["rageadd"] = rangBeAtk;
            
            local tmpos = var["pos"];
            if(bLeft)then
                tmpos = tmpos - xPetCnt*yPetCnt;
            end

            for tk,tv in ipairs(defpets) do
                if(tv["pos"]==tmpos)then
                    tv["rage"] = tv["rage"] + rangBeAtk;
                end
            end
        end
    end

    return petRet;
end


local function getFightList(petAtk,petDef)

    local AtkY = 0; --攻击轮次
    local atkList = {};
    local win;

    local lc =0;
    local rc =0;
  --  local rAtkY = 0; --右边的攻击轮次
    while true do
        print("time to begin fl1",os.clock());
        --现在是左边攻击
        local leftAtk =nil; --攻击的人
        for i=lc,xPetCnt*yPetCnt-1 do
            local ii = i%(xPetCnt*yPetCnt);
            for k,var in ipairs(petAtk) do
               if(var["pos"]==ii and var["bld_cur"]>0)then
                    leftAtk = var;
                    break;
               end
            end

        if leftAtk then break end;
            
        end

        leftDef = nil; --被攻击的人
        if(leftAtk)then 
            local sk;
            local rageAdd;
            if(leftAtk["rage"]>=rageSum) then
                --技能攻击
                sk = petConf["info"][tostring(leftAtk["id"])]["petskill"] or 0;
                rageAdd = 0-leftAtk["rage"];
            else
                --普通攻击
                sk =PET_SK.NO_SK;
                --sk = 45;
                rageAdd = ragePerAtk;


            end
            local leftDef = getAtkAndBld(sk,leftAtk,petAtk,petDef,true);
            if(not leftDef)then
                win = true;
                break;
            end
            leftAtk["rage"] = leftAtk["rage"]+ rageAdd;
            atkList[#atkList+1] = {["atkpos"]=leftAtk["pos"] , ["rageadd"] = rageAdd,["defs"]=leftDef,["sk"] = sk ,["petid"] = leftAtk["id"]};

           
            --     if(leftDef["bld_cur"]<0)
            lc = leftAtk["pos"]+1;
        end

 --       lc = (lc+1)%(xPetCnt*yPetCnt);
            


        --现在是右边攻击


        local rightAtk =nil; --攻击的人
        for i=rc,xPetCnt*yPetCnt-1 do
            local ii = i%(xPetCnt*yPetCnt);
            --print("iiiiiii",ii);
            for k,var in ipairs(petDef) do
               if(var["pos"]==ii and var["bld_cur"]>0)then
                    rightAtk = var;
                    break;
               end
            end

        if rightAtk then break end;
            
        end

        rightDef = nil; --被攻击的人
        if(rightAtk)then 

            local sk;
            local rageAdd;
            if(rightAtk["rage"]>=rageSum) then
                --技能攻击
                sk = petConf["info"][tostring(rightAtk["id"])]["petskill"] or 0;
                rageAdd = 0-rightAtk["rage"];
            else
                --普通攻击
                sk =PET_SK.NO_SK;
                --sk =math.random(42,45);

                rageAdd = ragePerAtk;


            end
            local rightDef = getAtkAndBld(sk,rightAtk,petDef,petAtk,false);
            if(not rightDef)then
                win = false;
                break;
            end
            rightAtk["rage"] = rightAtk["rage"]+ rageAdd;
            atkList[#atkList+1] = {["atkpos"]=rightAtk["pos"]+xPetCnt*yPetCnt , ["rageadd"] = rageAdd,["defs"]=rightDef,["sk"] = sk ,["petid"] = rightAtk["id"]};

           
           
            --     if(rightDef["bld_cur"]<0)
            rc = rightAtk["pos"]+1;
          --  print("rc is ",rc);
        end
        
        if not (leftAtk or rightAtk) then
            lc = 0;
            rc = 0;
        end

        if(#atkList>100)then
            print("more than 50 times");
            win = false;
            break;
        end
        --rc = (rc+1)%(xPetCnt*yPetCnt);
       -- print("rc++ is ",rc);
        --下一行
        
      --  AtkY = (AtkY +1)%yPetCnt;
    end;

    local l = #atkList;
    local endAction = atkList[l];
    if(endAction and endAction["defs"][1]["bld_add"]>0) then
        table.remove(atkList,l);
    end
--    logJson(atkList);
  --  print(win);
    return atkList,win;
end

local function getAddBldFunc(defPos,bldnum,atkType)
    print("pos sub["..defPos.."] bld ["..bldnum.."]");
    local wordType = atkType or 2;
    return function()

        local lastStats;
        local curStats;
        local maxBld = petStats[defPos]["bld_max"];
        local lr = petStats[defPos]["bld"]/maxBld;
        if(lr>0.6)then 
            lastStats = 3;
        elseif(lr>0.3) then
            lastStats = 2;
        else 
            lastStats = 1;
        end

        petStats[defPos]["bld"] = petStats[defPos]["bld"] + bldnum;

        local cr = petStats[defPos]["bld"]/maxBld;
        if(cr>0.6)then 
            curStats = 3;
        elseif(cr>0.3) then
            curStats = 2;
        else 
            curStats = 1;
        end

        if(curStats~=lastStats)then
            local img = "hp_progress"
            if(curStats==1)then
                img = img..".png"
            else
                img = img..curStats..".png"
            end            
            local pBldSlider = CCControlSlider:create("hp_bg.png",img, "transparent.png");
            pBldSlider:setMinimumValue(0.0) ;
            pBldSlider:setMaximumValue(maxBld) ;
            pBldSlider:setPosition(ccp(petStats[defPos]["bldSld"]:getPositionX(),petStats[defPos]["bldSld"]:getPositionY()));
            pBldSlider:setScale(petStats[defPos]["bldSld"]:getScale());
            petStats[defPos]["namenode"]:addChild(pBldSlider,2);
            petStats[defPos]["bldSld"]:removeFromParentAndCleanup(true);
            petStats[defPos]["bldSld"] = pBldSlider;
        end
        
        petStats[defPos]["bldSld"]:setValue(petStats[defPos]["bld"]);

        
        local x;
        local y;
        x,y = petStats[defPos]["namenode"]:getPosition();

        --CCControlSlider:getMaximumValue();
        if(petStats[defPos]["bld"]<=0)then
            print("bld<0",petStats[defPos]["bld"]);
            petStats[defPos]["sprite"]:stopAllActions();
            petStats[defPos]["sprite"]:setVisible(true);
            petStats[defPos]["namenode"]:removeFromParentAndCleanup(true);
            petStats[defPos]["foot"]:removeFromParentAndCleanup(true);
            petStats[defPos]["sprite"]:removeAllChildrenWithCleanup(true);
            petStats[defPos]["sprite"]:setScale(1.0);
            petStats[defPos]["sprite"]:setFlipX(defPos>=yPetCnt*xPetCnt);
            local animation = CCAnimation:create();
            local  name;
            for i = 1, 13 do
                name = "petdead"..i..".png";
                local spf = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(name);
                animation:addSpriteFrame(spf);
            end
            --playEffect(EFFECT_MUSIC.MW_PET_FIGHT_DEAD);
			
			
            --local endspf = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("petdead6.png");
            --animation:addSpriteFrame(endspf);
            animation:setDelayPerUnit(0.08*speedRate);
            local deadaction = CCAnimate:create(animation);
            petStats[defPos]["sprite"]:runAction(CCSequence:createWithTwoActions(deadaction,CCCallFunc:create(function() petStats[defPos]["sprite"]:removeFromParentAndCleanup(true) end)));

        end

           -- print("bld runAction");
            local bld;
            if(bldnum~=0)then
                local str;
                if(bldnum<0)then
                    if(wordType==1)then
                        str = "/"..math.abs(bldnum);
                        bld = CCLabelAtlas:create(str,"pvpBloodNum.png",31,39,46);
                    else
                        str = tostring(math.abs(bldnum));

                        bldFnt = CCLabelBMFont:create(str,"fonts/crit.fnt");

                        bld = CCSprite:create("petSkillAni/crit_bg.png");
                        bld:setScale(0.5);
                        bld:addChild(bldFnt,1);
                        bldFnt:setScale(2.0);
                        bldFnt:setPosition(ccp(bld:getContentSize().width*0.5,bld:getContentSize().height*0.5));
                    end
                else
                    str = "."..math.abs(bldnum);
                    bld = CCLabelAtlas:create(str,"pvpAddBloodNum.png",31,39,46);
                end
              --  print(str);
                
                
                bld:setAnchorPoint(ccp(0.5,0.5));
            else
                bld = CCSprite:create("link/miss.png");
            end

            

            bld:setPosition(ccp(x,y));
            petLayer:addChild(bld,100);
            if(bldnum<0 and wordType~=1)then
            
                bld:runAction(CCSequence:createWithTwoActions(CCEaseExponentialOut:create(CCScaleBy:create(0.5*speedRate, 2.0)),CCCallFunc:create(function() bld:removeFromParentAndCleanup(false) end)));
            else
                bld:runAction(CCSequence:createWithTwoActions(CCMoveBy:create(1.5*speedRate, ccp(0,100)),CCCallFunc:create(function() bld:removeFromParentAndCleanup(false) end)));
            end

            if(bldnum<=0)then
                playEffect(EFFECT_MUSIC.MW_PET_FIGHT_ATK);
                if(petStats[defPos]["bld"]>0)then 
                    local array = CCArray:create();                
                    -- CCNode:removeFromParentAndCleanup(true);
                    array:addObject(CCRotateTo:create(0.05,-30));
                    array:addObject(CCRotateTo:create(0.05,20));
                    array:addObject(CCRotateTo:create(0.05,-10));
                    array:addObject(CCRotateTo:create(0.05,5));
                    array:addObject(CCRotateTo:create(0.05,0));
                    local action = CCSequence:create(array);
                    petStats[defPos]["sprite"]:runAction(action);
                end
            else
                local bldSp = CCSprite:create();
                petLayer:addChild(bldSp,100);
                bldSp:setPosition(petStats[defPos]["sprite"]:getPosition());

                local bldAnimation = createMwllAnimation("petFight/addbld.plist","addbld_",1,12,0.08*speedRate);
                local bldAction = CCAnimate:create(bldAnimation);
                
                bldSp:runAction(CCSequence:createWithTwoActions(bldAction,CCCallFunc:create(function() bldSp:removeFromParentAndCleanup(false) end)));
            end



    end
end

local function getSkPos(pos)
    local p;
    if(pos>=xPetCnt*yPetCnt)then
        p = ccp(gCenterX + 20 ,gCenterY+50 -(pos-xPetCnt*yPetCnt)%yPetCnt*230);
--        print("get sk pos x ",p.x);
    else
        p = ccp(gCenterX - 20 ,gCenterY+50 -pos%yPetCnt*230);
    end
    return p;
    
end


local function getPosOfPos(pos)
    local p;
    if(pos>=xPetCnt*yPetCnt)then
        p = ccp(gCenterX + 150 + 130*math.floor((pos-xPetCnt*yPetCnt)/yPetCnt),gCenterY+50 -(pos-xPetCnt*yPetCnt)%yPetCnt*230);
--        print("get pos of  pos x ",p.x);
    else
        p = ccp(gCenterX - 150 - 130*math.floor(pos/yPetCnt),gCenterY+50 -pos%yPetCnt*230);
    end
    return p;
end

local function playBeAtkByType(skType,pos)

    if(skType==1)then
        local arma = createArmatureLua("petSkillAni/pet_sk_type1.ExportJson","pet_sk_type1", "petSkillAni/pet_sk_type10.plist");
        arma:getAnimation():play("skill2a",-1,0);
        arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(0,-80)));
        petLayer:addChild(arma,100);
        if(pos>=yPetCnt*xPetCnt) then
            arma:setScaleX(arma:getScaleX()*-1);
        end
        
        --petStats[pos]["sprite"]:setVisible(false);
        --petStats[pos]["sprite"]:retain();        
        arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
        arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                arma:removeFromParentAndCleanup(false);
                --petStats[pos]["sprite"]:setVisible(true);
                --petStats[pos]["sprite"]:release();       
            end
        end);
    elseif(skType==2)then
        local arma = createArmatureLua("petSkillAni/pet_sk_type2.ExportJson","pet_sk_type2", "petSkillAni/pet_sk_type20.plist");
        arma:getAnimation():play("skill4a",-1,0);
        arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(0,-80)));
        petLayer:addChild(arma,100);
        if(pos<yPetCnt*xPetCnt) then
            arma:setScaleX(arma:getScaleX()*-1);
        end
        
       -- petStats[pos]["sprite"]:setVisible(false);
       -- petStats[pos]["sprite"]:retain();        
        arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
        arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                arma:removeFromParentAndCleanup(false);
             --   petStats[pos]["sprite"]:setVisible(true);
             --   petStats[pos]["sprite"]:release();       
            end
        end);

    elseif(skType==3)then
        --print("aaaaaaaaaaaaa");
        local arma = createArmatureLua("petSkillAni/pet_sk_type3.ExportJson","pet_sk_type3", "petSkillAni/pet_sk_type30.plist");
        arma:getAnimation():play("skill2a",-1,0);
        arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(-240,-60)));
        petLayer:addChild(arma,100);
        if(pos<yPetCnt*xPetCnt) then
            arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(240,-60)));
            arma:setScaleX(arma:getScaleX()*-1);
        end
        
       -- petStats[pos]["sprite"]:setVisible(false);
       -- petStats[pos]["sprite"]:retain();        
        arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
        arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                arma:removeFromParentAndCleanup(false);
             --   petStats[pos]["sprite"]:setVisible(true);
             --   petStats[pos]["sprite"]:release();       
            end
        end);
    elseif(skType==4)then
        local arma = createArmatureLua("petSkillAni/pet_sk_type4.ExportJson","pet_sk_type4", "petSkillAni/pet_sk_type40.plist");
        arma:getAnimation():play("skill4a",-1,0);
        arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(40,-80)));
        petLayer:addChild(arma,100);
        if(pos<yPetCnt*xPetCnt) then
            arma:setScaleX(arma:getScaleX()*-1);
            arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(-40,-80)));
        end
        
        petStats[pos]["sprite"]:setVisible(false);
        petStats[pos]["sprite"]:retain();        
        arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
        arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                arma:removeFromParentAndCleanup(false);
                petStats[pos]["sprite"]:setVisible(true);
                petStats[pos]["sprite"]:release();       
            end
        end);
    elseif(skType==5)then
        local arma = createArmatureLua("petSkillAni/pet_sk_type5.ExportJson","pet_sk_type5", "petSkillAni/pet_sk_type50.plist");
        arma:getAnimation():play("skill2a",-1,0);
        arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(40,-80)));
        petLayer:addChild(arma,100);
        if(pos<yPetCnt*xPetCnt) then
            arma:setScaleX(arma:getScaleX()*-1);
            arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(-40,-80)));
        end
        
        petStats[pos]["sprite"]:setVisible(false);
        petStats[pos]["sprite"]:retain();        
        arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
        arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                arma:removeFromParentAndCleanup(false);
                petStats[pos]["sprite"]:setVisible(true);
                petStats[pos]["sprite"]:release();       
            end
        end);
    else
        local arma = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
        arma:getAnimation():play("skill4a",-1,0);
        arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(0,0)));
        petLayer:addChild(arma,100);
        if(pos<yPetCnt*xPetCnt) then
            arma:setScaleX(arma:getScaleX()*-1);
            arma:setPosition(ccpAdd(getPosOfPos(pos),ccp(0,0)));
        end
        
        petStats[pos]["sprite"]:setVisible(false);
        petStats[pos]["sprite"]:retain();        
        arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
        arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                arma:removeFromParentAndCleanup(false);
                petStats[pos]["sprite"]:setVisible(true);
                petStats[pos]["sprite"]:release();       
            end
        end);
    end

end

local function playOneStep()

    if(lastSkPos)then
        local tmpPetId = petStats[lastSkPos]["sprite"]:getTag();
        if(petPosConf[tostring(tmpPetId)])then
            petStats[lastSkPos]["sprite"]:setPosition(ccpAdd(getPosOfPos(lastSkPos),ccp(petPosConf[tostring(tmpPetId)]["coordinateX"],petPosConf[tostring(tmpPetId)]["coordinateY"])));
            
        else
            petStats[lastSkPos]["sprite"]:setPosition(getPosOfPos(lastSkPos));
        end
        
        lastSkPos = nil;
    end

    if(curStep>#m_ActionList)then
        showGameResult();
        return;
    end
    

    local showAction = function()


        local actionJson = m_ActionList[curStep];
        local atkPos = actionJson["atkpos"];


        local defPos = actionJson["defs"][1]["pos"];
        local atkPet = petStats[atkPos]["sprite"];
        local defPet = petStats[defPos]["sprite"];
        local petId = getDescId(actionJson["petid"]);

        curStep = curStep+1;
        

        --local ragevalue = petStats[atkPos]["rageSld"]:getValue()+actionJson["rageadd"];
        --petStats[atkPos]["rageSld"]:setValue(ragevalue);

        local tmpRage = tonumber(petStats[atkPos]["rageSld"]:getString());
        local ragevalue = tmpRage + actionJson["rageadd"];
        if(ragevalue>=rageSum and tmpRage<rageSum)then
            local x,y = petStats[atkPos]["rageBg"]:getPosition()
            local p = ccpAdd(ccp(x,y),ccp(0,10));
            local newBg = CCSprite:create();
            local ragefire = createMwllAnimation("petFight/rageani.plist", "rageani",1  ,6, 0.1*speedRate);
            local rageani = CCAnimate:create(ragefire);
            newBg:runAction(CCRepeatForever:create(rageani));
            newBg:setPosition(p);
            petStats[atkPos]["rageBg"]:getParent():addChild(newBg,3);
            petStats[atkPos]["rageBg"]:removeFromParentAndCleanup(false);
            petStats[atkPos]["rageBg"] = nil;
            petStats[atkPos]["rageBg"] = newBg;
        end

        petStats[atkPos]["rageSld"]:setString(math.min(math.max(ragevalue,0),rageSum));

        if(actionJson["sk"]~=PET_SK.NO_SK)then
            local x,y = petStats[atkPos]["rageBg"]:getPosition()
            local p = ccpAdd(ccp(x,y),ccp(0,-10));
            --local newBg = CCSprite:create("petFight/rageBg.png");
            local pRageBgSp = CCSprite:create("petFight/rageBg.png");
            local newBg = CCProgressTimer:create(pRageBgSp);
            newBg:setAnchorPoint(ccp(0.5,0.5));
            newBg:setType(kCCProgressTimerTypeRadial);
            newBg:setPercentage(0);
            newBg:setPosition(p);
            petStats[atkPos]["rageBg"]:getParent():addChild(newBg,3);
            petStats[atkPos]["rageBg"]:removeFromParentAndCleanup(false);
            petStats[atkPos]["rageBg"] = nil;
            petStats[atkPos]["rageBg"] = newBg;
        end

        if(ragevalue<rageSum)then
            petStats[atkPos]["rageBg"]:setPercentage(math.min(math.max(ragevalue,0),rageSum));
            petStats[atkPos]["ragebbg"]:setVisible(true);
        else
            petStats[atkPos]["ragebbg"]:setVisible(false);
        end

        for k,v in ipairs(actionJson["defs"])do
            local ttp = v["pos"];
           -- local rv = tonumber(petStats[ttp]["rageSld"]:getString())+v["rageadd"];
          --  petStats[ttp]["rageSld"]:setString(math.min(math.max(rv,0),rageSum));

        
            local tmptRage = tonumber(petStats[ttp]["rageSld"]:getString());
            local tragevalue = tmptRage +  actionJson["defs"][k]["rageadd"];
            petStats[ttp]["rageSld"]:setString(math.min(math.max(tragevalue,0),rageSum));
            if(tragevalue>=rageSum and tmptRage<rageSum)then
                local x,y = petStats[ttp]["rageBg"]:getPosition();
                local p = ccpAdd(ccp(x,y),ccp(0,10));
                CCLuaLog("tragevalue "..tragevalue);
                local newBg = CCSprite:create();
                local ragefire = createMwllAnimation("petFight/rageani.plist", "rageani",1  ,6, 0.1*speedRate);
                local rageani = CCAnimate:create(ragefire);
                newBg:runAction(CCRepeatForever:create(rageani));
                newBg:setPosition(p);
                petStats[ttp]["rageBg"]:getParent():addChild(newBg,3);
                petStats[ttp]["rageBg"]:removeFromParentAndCleanup(false);
                petStats[ttp]["rageBg"] = nil;
                petStats[ttp]["rageBg"] = newBg;
            end

            if(tragevalue<rageSum)then
                petStats[ttp]["rageBg"]:setPercentage(math.min(math.max(tragevalue,0),rageSum));
                petStats[ttp]["ragebbg"]:setVisible(true);
            else
                petStats[ttp]["ragebbg"]:setVisible(false);
            end

            
        end


        local desplayPos = atkPos;
        if(actionJson["sk"]==PET_SK.COLUMN or actionJson["sk"] ==PET_SK.PET_SK_25 or actionJson["sk"] ==PET_SK.PET_SK_29 or actionJson["sk"] ==PET_SK.PET_SK_33 or actionJson["sk"] ==PET_SK.PET_SK_37 or actionJson["sk"] ==PET_SK.PET_SK_41 or actionJson["sk"] ==PET_SK.PET_SK_45  or  actionJson["sk"] ==PET_SK.PET_SK_35 or actionJson["sk"] ==PET_SK.PET_SK_27  or actionJson["sk"] ==PET_SK.PET_SK_23 or actionJson["sk"] ==PET_SK.PET_SK_43 )then
        
            desplayPos = desplayPos - desplayPos%yPetCnt + actionJson["defs"][1]["pos"]%yPetCnt;
        end
        if(actionJson["sk"]~=PET_SK.NO_SK)then
            atkPet:setPosition(getSkPos(desplayPos));
            lastSkPos = atkPos;
        end

        if(petAniConf[tostring(petId)]) then
            atkPet:setVisible(false);
            local petAtkAni = CCAnimation:create();
            local tmpSp = CCSprite:create();
            petLayer:addChild(tmpSp,10);
            tmpSp:setPosition(atkPet:getPosition());
            tmpSp:setFlipX(atkPos>=yPetCnt*xPetCnt);
            local imgList = spiltArray(petAniConf[tostring(petId)]["atk_list"],".");
            for idx,var in ipairs(imgList) do
            
                local imgName = string.format("petSkill/%d/%s.png",petId,var);
                petAtkAni:addSpriteFrameWithFileName(imgName);
            end
            petAtkAni:setRestoreOriginalFrame(true);
            petAtkAni:setDelayPerUnit(petAniConf[tostring(petId)]["atk_inv"]*speedRate);
            local atkAct = CCAnimate:create(petAtkAni);
            local cb = CCCallFunc:create(function() 
                tmpSp:removeFromParentAndCleanup(false);
                atkPet:setVisible(true);
            end);
            tmpSp:runAction(CCSequence:createWithTwoActions(atkAct,cb));
            tmpSp:setScale(petScaleConf);
        else
            atkPet:runAction(CCSequence:createWithTwoActions(CCMoveBy:create(0.25*speedRate, ccp(0,50)),CCMoveBy:create(0.25*speedRate, ccp(0,-50))));
            petStats[atkPos]["foot"]:runAction(CCSequence:createWithTwoActions(CCScaleBy:create(0.25*speedRate,0.9),CCScaleBy:create(0.25*speedRate,1/0.9)));
        end

        --宠物攻击动作
        if(actionJson["sk"]==PET_SK.NO_SK) then

            --没有技能的动作    

        

            local bullet = CCSprite:create();
            bullet:setFlipX(atkPos>=yPetCnt*xPetCnt);
            bullet:setPosition(atkPet:getPosition());
            petLayer:addChild(bullet,100);

            local bulletAnimation = CCAnimation:create();
            local  name;
            for i = 1, 4 do
                name = string.format("pet_attack_%d_%02d.png",petStats[atkPos]["type"],i);
                local spf = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(name);
                bulletAnimation:addSpriteFrame(spf);
            end

            bulletAnimation:setDelayPerUnit(0.08*speedRate);
            local bulletAction = CCAnimate:create(bulletAnimation);
            bullet:runAction(CCRepeatForever:create(bulletAction));


            local array = CCArray:create();
            local x,y = defPet:getPosition();
            local fly = CCMoveTo:create(0.5*speedRate,ccp(x,y));
            array:addObject(fly);



            for i,v in ipairs(actionJson["defs"]) do
                local addBld = CCCallFunc:create(getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"],1));
                array:addObject(addBld);
            end


            array:addObject(CCCallFunc:create(function() bullet:stopAction(bulletAction); end));

            local head = string.format("bullet_boom_%d_",petStats[atkPos]["type"]);
            local bulletbomb = createMwllAnimation("petFight/bullet_boom.plist", head, 1, 6, 0.08*speedRate);
            local bombact = CCAnimate:create(bulletbomb);
            array:addObject(CCCallFunc:create(function() 

                local head = string.format("bullet_boom_%d_",petStats[atkPos]["type"]);
                local bulletbomb = createMwllAnimation("petFight/bullet_boom.plist", head, 1, 6, 0.08*speedRate);
                local bombact = CCAnimate:create(bulletbomb);
                local tsp = CCSprite:create();
                petLayer:addChild(tsp,101);
                tsp:setPosition(ccp(x,y));
                tsp:runAction(CCSequence:createWithTwoActions(bombact,CCCallFunc:create(function() tsp:removeFromParentAndCleanup(false); end)));
        
             end));

           -- CCNode:removeFromParentAndCleanup(true);
            array:addObject(CCCallFunc:create(function() bullet:setVisible(false); end));
            array:addObject(CCDelayTime:create(0.5*speedRate));
            array:addObject(CCCallFunc:create(playOneStep));
            array:addObject(CCCallFunc:create(function() bullet:removeFromParentAndCleanup(true); end));

            local action = CCSequence:create(array);

            bullet:runAction(action);
        elseif(actionJson["sk"]==PET_SK.FIRST_ROW or actionJson["sk"]==PET_SK.SECOND_ROW or actionJson["sk"]==PET_SK.THIRD_ROW )then

            --攻击一排
            local bullet = CCSprite:create();
            local fx;
            local offsetPos;
            if(atkPos<yPetCnt*xPetCnt) then
                fx = true;
                offsetPos = ccp(0,120);
            else
                fx = false;
                offsetPos = ccp(-0,120);
            end

            bullet:setFlipX(fx);
            local tmpPos = actionJson["defs"][1]["pos"] - actionJson["defs"][1]["pos"]%yPetCnt + 1;
        
            bullet:setPosition(ccpAdd(getPosOfPos(tmpPos),offsetPos));
            petLayer:addChild(bullet,100);
            local bulletAnimation = createMwllAnimation("petFight/row1.plist","row1_",1,10,0.05*speedRate);
            local bulletAction = CCAnimate:create(bulletAnimation);
            local array = CCArray:create();
            array:addObject(bulletAction);
            for i,v in ipairs(actionJson["defs"]) do
                local addBld = CCCallFunc:create(getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]));
                array:addObject(addBld);
            end
            array:addObject(CCCallFunc:create(function() bullet:setVisible(false); end));
            array:addObject(CCDelayTime:create(step_intrvl*speedRate));
            array:addObject(CCCallFunc:create(playOneStep));
            array:addObject(CCCallFunc:create(function() bullet:removeFromParentAndCleanup(true); end));

            local action = CCSequence:create(array);

            bullet:runAction(action);


        elseif(actionJson["sk"]==PET_SK.RANDOM_3 or actionJson["sk"]==PET_SK.SINGLE)then
            local bullet = CCSprite:create();
            local fx;
            local offsetPos;

            if(atkPos<yPetCnt*xPetCnt) then
                fx = true;
                offsetPos = ccp(-10,100);

            else
                fx = false;
                offsetPos = ccp(10,100);

            end
            bullet:setFlipX(fx);
            petLayer:addChild(bullet,100);

            local array = CCArray:create();
            for i,v in ipairs(actionJson["defs"]) do
                local pos = ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),offsetPos);
                array:addObject(CCMoveTo:create(0*speedRate,pos));
                local bulletAnimation = createMwllAnimation("petFight/petlight.plist","petlight_",1,9,0.08*speedRate);
                local bulletAction = CCAnimate:create(bulletAnimation);
                array:addObject(bulletAction);
                local addBld = CCCallFunc:create(getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]));
                array:addObject(addBld);
            end

            array:addObject(CCCallFunc:create(function() bullet:setVisible(false); end));
            array:addObject(CCDelayTime:create(step_intrvl*speedRate));
            array:addObject(CCCallFunc:create(playOneStep));
            array:addObject(CCCallFunc:create(function() bullet:removeFromParentAndCleanup(true); end));

            local action = CCSequence:create(array);
            bullet:runAction(action);

        elseif(actionJson["sk"]==PET_SK.COLUMN)then
            local bullet = CCSprite:create();
            bullet:setFlipX(atkPos<yPetCnt*xPetCnt);
            bullet:setPosition(atkPet:getPosition());
            petLayer:addChild(bullet,100);
            local bulletAnimation = createMwllAnimation("petFight/column.plist","column_",1,4,0.05*speedRate);
            bulletAnimation:setLoops(-1);
            local bulletAction = CCAnimate:create(bulletAnimation);
            bullet:runAction(bulletAction);

            local array = CCArray:create();

            local fx;
            local bombOff;
            local bulletOff;
            if(atkPos<yPetCnt*xPetCnt) then
                fx = true;
                bombOff = ccp(-50,0);
                bulletOff = ccp(800,0);
            else
                fx = false;
                bombOff = ccp(50,0);
                bulletOff = ccp(-800,0);
            end

            local tx,ty = atkPet:getPosition();
            local tp = ccp(tx,ty);
            for i,v in ipairs(actionJson["defs"]) do
                local tarPos = getPosOfPos(actionJson["defs"][i]["pos"]);
                local dis = ccpDistance(tarPos,tp);
                array:addObject(CCMoveTo:create(dis/800*speedRate,tarPos));
                tp = tarPos;

                local bombAct = CCCallFunc:create(function () 
                    local bomb = CCSprite:create();
                    petLayer:addChild(bomb,101);
                    bomb:setPosition(ccpAdd(tarPos,bombOff));
                    bomb:setFlipX(not fx);
                    local bombAnimation = createMwllAnimation("link/link_ani.plist","link_hit_",2,6,0.1*speedRate);
                    local bombAction = CCAnimate:create(bombAnimation);
                    bomb:runAction(CCSequence:createWithTwoActions(bombAction,CCCallFunc:create(function () bomb:removeFromParentAndCleanup(false) end)));


            
                end);

                array:addObject(bombAct);
                local addBld = CCCallFunc:create(getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]));
                array:addObject(addBld);
            end
            --array:addObject(CCCallFunc:create(function() bullet:setVisible(false); end));

            array:addObject(CCCallFunc:create(function() bullet:runAction(CCMoveBy:create(1*speedRate,bulletOff)); end));
            array:addObject(CCDelayTime:create(step_intrvl*speedRate));
            array:addObject(CCCallFunc:create(playOneStep));
            array:addObject(CCCallFunc:create(function() bullet:removeFromParentAndCleanup(true); end));

            local action = CCSequence:create(array);
            bullet:runAction(action);


        elseif(actionJson["sk"]==PET_SK.ALL)then
            local tList ={};
            for i=1,#actionJson["defs"] do
                tList[i] = i*0.3;
            end
            local maxt = #actionJson["defs"]*0.3;
            local rList = {};
            for i=1,#actionJson["defs"] do
                local idx = math.random(1, #tList);
                rList[#rList+1] = tList[idx];
                table.remove(tList,idx);
            end

            local fx;
            local bombOff;
            local bulletOff;
            if(atkPos>=yPetCnt*xPetCnt) then
                fx = false;
                bombOff = ccp(200,280);
                bulletOff = ccp(800,0);
            else
                fx = true;
                bombOff = ccp(-200,280);
                bulletOff = ccp(-800,0);
            end

            for i=1,#actionJson["defs"] do
                local bullet = CCSprite:create("petFight/rocket.png");
                bullet:setVisible(false);
                local tpos = getPosOfPos(actionJson["defs"][i]["pos"]);
                bullet:setPosition(ccpAdd(bombOff,tpos));
                bullet:setFlipX(fx);
                petLayer:addChild(bullet,100);

                local miao = CCSprite:create();
                miao:setPosition(tpos);
                petLayer:addChild(miao,100);
                local miaoAnimation = createMwllAnimation("link/miaozhun.plist","miaozhun",1,5,0.08*speedRate);
                miaoAnimation:setLoops(-1);
                local miaoAction = CCAnimate:create(miaoAnimation);
                miao:runAction(miaoAction);

                local array = CCArray:create();
                array:addObject(CCDelayTime:create(rList[i]*speedRate));
                array:addObject(CCCallFunc:create(function() bullet:setVisible(true); end));
                array:addObject(CCMoveTo:create(0.3*speedRate,tpos));

                local addBld = CCCallFunc:create(getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]));
                array:addObject(addBld);

                array:addObject(CCCallFunc:create(function() miao:removeFromParentAndCleanup(false); end));

                local bombAnimation = createMwllAnimation("petFight/bigbomb.plist","bigbomb_",1,8,0.08*speedRate);
                local bombAction = CCAnimate:create(bombAnimation);
                array:addObject(bombAction);

                if(rList[i]==maxt)then
                    array:addObject(CCDelayTime:create(step_intrvl*speedRate));
                    array:addObject(CCCallFunc:create(playOneStep));
                end
                array:addObject(CCCallFunc:create(function() bullet:removeFromParentAndCleanup(false); end));
                local action = CCSequence:create(array);
                bullet:runAction(action);
            end
         elseif(actionJson["sk"]==PET_SK.PET_SK_22)then
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            local yNum = math.floor(actionJson["defs"][1]["pos"]/yPetCnt);

            for i,v in ipairs(actionJson["defs"]) do
                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
            end

            for i=1,yPetCnt do
                
                local tpos = yPetCnt*yNum+i-1;
       
                local arma = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
                arma:getAnimation():play("skill1",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(0,-50)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(0,-50)));
                end
                
                
                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   playBeAtkByType(6,actionJson["defs"][idx]["pos"] );
                                   addBldList[idx]();

                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_23)then
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            for i,v in ipairs(actionJson["defs"]) do
                           
                local arma = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
                arma:getAnimation():play("skill2",-1,1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,0)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    
                end

                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));

                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                
                local array = CCArray:create();
                
                array:addObject(CCMoveTo:create(0.3*speedRate,getPosOfPos(actionJson["defs"][i]["pos"])));

                if(i==1)then
                    array:addObject(CCCallFunc:create(function()
                        armaLayer:removeFromParentAndCleanup(false);
                        for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   addBldList[idx]();
                                   --playBeAtkByType(6,actionJson["defs"][idx]["pos"] );
                                   local bombarma = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
                                    bombarma:getAnimation():play("skill2a",-1,0);
                                    bombarma:getAnimation():setSpeedScale((1/speedRate));
                                    bombarma:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][idx]["pos"]),ccp(0,0)));
                                    petLayer:addChild(bombarma,100);
                                    bombarma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                                    if(b==2)then
                                            bombarma:removeFromParentAndCleanup(false);
                                        end
                                    end);
                        end
                    end));

                    array:addObject(CCCallFunc:create(playOneStep));
                end
                local action = CCSequence:create(array);
                arma:runAction(action);
                

            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_24)then
            local arma = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
            arma:getAnimation():play("skill3",-1,0);
            arma:setPosition(ccpAdd(gCenter,ccp(270,-200)));
            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(gCenter,ccp(-270,-200)));
            end

            arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);        
                    playOneStep();
                end
            end);

            local armaBombList = {};
            local bldFuncList = {};
            for i,v in ipairs(actionJson["defs"]) do
                armaBombList[i] = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
                armaBombList[i]:setTag(i);
                armaBombList[i]:getAnimation():play("skill2a",-1,0);
                armaBombList[i]:getAnimation():setSpeedScale((1/speedRate));
                armaBombList[i]:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,0)));
                petLayer:addChild(armaBombList[i],3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    armaBombList[i]:setScaleX(armaBombList[i]:getScaleX()*-1);
                end
                bldFuncList[i] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                armaBombList[i]:getAnimation():setMovementEventCallFunc(function(a,b,c)
                    if(b==2)then
                        local tagp = a:getTag();
                        armaBombList[tagp]:removeFromParentAndCleanup(false);                       
                        bldFuncList[tagp]();      
                     end
                end);
    
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_25)then
            local arma = createArmatureLua("petSkillAni/pet_sk_type6.ExportJson","pet_sk_type6", "petSkillAni/pet_sk_type60.plist");
            arma:getAnimation():play("skill4",-1,0);

            
            local p ;
            local px = atkPos - atkPos%yPetCnt;
            local py = actionJson["defs"][1]["pos"]%yPetCnt;
            p = px+py;

           -- print("px is ",atkPos,"py ix ",JSON:encode(actionJson));

            arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-80)));

            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-80)));
                
            end
            arma:getAnimation():setSpeedScale(0.8*(1/speedRate));
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(6,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);
        --暗系
        elseif(actionJson["sk"]==PET_SK.PET_SK_26)then
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            local yNum = actionJson["defs"][1]["pos"]/yPetCnt;

            for i,v in ipairs(actionJson["defs"]) do
                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
            end

            for i=1,yPetCnt do
                
                local tpos = yPetCnt*yNum+i-1;
       
                local arma = createArmatureLua("petSkillAni/pet_sk_type5.ExportJson","pet_sk_type5", "petSkillAni/pet_sk_type50.plist");
                arma:getAnimation():play("skill1",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(0,-80)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                end
                
                
                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   playBeAtkByType(5,actionJson["defs"][idx]["pos"] );
                                   addBldList[idx]();

                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_27)then
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            for i,v in ipairs(actionJson["defs"]) do
                           
                local arma = createArmatureLua("petSkillAni/pet_sk_type5.ExportJson","pet_sk_type5", "petSkillAni/pet_sk_type50.plist");
                arma:getAnimation():play("skill2",-1,0);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-85)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-85)));
                end

                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));




                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                
                local array = CCArray:create();
                
                array:addObject(CCMoveTo:create(0.3*speedRate,ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-85))));

                if(i==1)then
                    array:addObject(CCCallFunc:create(function()
                        armaLayer:removeFromParentAndCleanup(false);
                        for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   addBldList[idx]();
                                   playBeAtkByType(5,actionJson["defs"][idx]["pos"] );
                                   
                        end
                    end));

                    array:addObject(CCCallFunc:create(playOneStep));
                end
                local action = CCSequence:create(array);
                arma:runAction(action);
     
            end
        
        elseif(actionJson["sk"]==PET_SK.PET_SK_28)then
            local armaLayer = CCLayer:create();
            petLayer:addChild(armaLayer,100);
            for tmpi =1,yPetCnt*xPetCnt do
                local arma = createArmatureLua("petSkillAni/pet_sk_type5.ExportJson","pet_sk_type5", "petSkillAni/pet_sk_type50.plist");
                arma:getAnimation():play("skill3",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(tmpi-1),ccp(-0,-100)));
                armaLayer:addChild(arma,3);
                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
                if(atkPos<yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getPosOfPos(tmpi-1+yPetCnt*xPetCnt),ccp(0,-100)));
                end

                if(tmpi==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for i,v in ipairs(actionJson["defs"]) do
                                --print("hahahhajax");
                                getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                                playBeAtkByType(5,actionJson["defs"][i]["pos"] );
                            end            
                            playOneStep();
                        end
                    end);
                end
            end
            

        
        elseif(actionJson["sk"]==PET_SK.PET_SK_29)then
            local arma = createArmatureLua("petSkillAni/pet_sk_type5.ExportJson","pet_sk_type5", "petSkillAni/pet_sk_type50.plist");
            arma:getAnimation():play("skill4",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            
            local p ;
            local px = atkPos - atkPos%yPetCnt;
            local py = actionJson["defs"][1]["pos"]%yPetCnt;
            p = px+py;

           -- print("px is ",atkPos,"py ix ",JSON:encode(actionJson));

            arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(-150,0)));

            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(150,0)));
                
            end
            --arma:getAnimation():setSpeedScale(0.5);
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(5,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);
            --电系
        elseif(actionJson["sk"]==PET_SK.PET_SK_30)then
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            local yNum = actionJson["defs"][1]["pos"]/yPetCnt;

            for i,v in ipairs(actionJson["defs"]) do
                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
            end
            playEffect(SK_MUSIC[actionJson["sk"]]);
            for i=1,yPetCnt do
                
                local tpos = yPetCnt*yNum+i-1;
       
                local arma = createArmatureLua("petSkillAni/pet_sk_type2.ExportJson","pet_sk_type2", "petSkillAni/pet_sk_type20.plist");
                arma:getAnimation():play("skill1",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(0,-80)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                end
                
                
                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   playBeAtkByType(2,actionJson["defs"][idx]["pos"] );
                                   addBldList[idx]();

                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_31)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            for i,v in ipairs(actionJson["defs"]) do
                           
                local arma = createArmatureLua("petSkillAni/pet_sk_type2.ExportJson","pet_sk_type2", "petSkillAni/pet_sk_type20.plist");
                arma:getAnimation():play("skill2",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-80)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                end

                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));

                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   addBldList[idx]();
                                   playBeAtkByType(2,actionJson["defs"][idx]["pos"] );
                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        
        elseif(actionJson["sk"]==PET_SK.PET_SK_32)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type2.ExportJson","pet_sk_type2", "petSkillAni/pet_sk_type20.plist");
            arma:getAnimation():play("skill3",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            arma:setPosition(ccpAdd(gCenter,ccp(-100,-160)));
            petLayer:addChild(arma,3);

            if(atkPos<yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(gCenter,ccp(100,-160)));
            end
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(2,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);
        
        elseif(actionJson["sk"]==PET_SK.PET_SK_33)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type2.ExportJson","pet_sk_type2", "petSkillAni/pet_sk_type20.plist");
            arma:getAnimation():play("skill4",-1,0);

            
            local p ;
            local px = atkPos - atkPos%yPetCnt;
            local py = actionJson["defs"][1]["pos"]%yPetCnt;
            p = px+py;

           -- print("px is ",atkPos,"py ix ",JSON:encode(actionJson));

            arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(100,-110)));

            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(-100,-110)));
                
            end
            arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(2,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);
        elseif(actionJson["sk"]==PET_SK.PET_SK_34)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            local yNum = math.floor(actionJson["defs"][1]["pos"]/yPetCnt);

            for i,v in ipairs(actionJson["defs"]) do
                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
            end

            for i=1,yPetCnt do
                
                local tpos = yPetCnt*yNum+i-1;
       
                local arma = createArmatureLua("petSkillAni/pet_sk_type1.ExportJson","pet_sk_type1", "petSkillAni/pet_sk_type10.plist");
                arma:getAnimation():play("skill1",-1,0);
                arma:getAnimation():setSpeedScale((1/speedRate));
                arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(-0,-100)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(0,-100)));
                end
                
                
                --arma:getAnimation():setSpeedScale(0.5);
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   playBeAtkByType(1,actionJson["defs"][idx]["pos"] );
                                   addBldList[idx]();

                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_35)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            for i,v in ipairs(actionJson["defs"]) do
                           
                local arma = createArmatureLua("petSkillAni/pet_sk_type1.ExportJson","pet_sk_type1", "petSkillAni/pet_sk_type10.plist");
                arma:getAnimation():play("skill2",-1,0);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-85)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-85)));
                end

                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));




                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                
                local array = CCArray:create();
                
                array:addObject(CCMoveTo:create(0.3*speedRate,ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-85))));

                if(i==1)then
                    array:addObject(CCCallFunc:create(function()
                        armaLayer:removeFromParentAndCleanup(false);
                        for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   addBldList[idx]();
                                   playBeAtkByType(1,actionJson["defs"][idx]["pos"] );
                                   
                        end
                    end));

                    array:addObject(CCCallFunc:create(playOneStep));
                end
                local action = CCSequence:create(array);
                arma:runAction(action);
     
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_36)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type1.ExportJson","pet_sk_type1", "petSkillAni/pet_sk_type10.plist");
            arma:getAnimation():play("skill3",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            arma:setPosition(ccpAdd(gCenter,ccp(120,-250)));
            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(gCenter,ccp(-120,-250)));
            end


            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);        
                    playOneStep();
                end
            end);

            local armaBombList = {};
            local bldFuncList = {};
            for i,v in ipairs(actionJson["defs"]) do
                armaBombList[i] = createArmatureLua("petSkillAni/pet_sk_type1.ExportJson","pet_sk_type1", "petSkillAni/pet_sk_type10.plist");
                armaBombList[i]:setTag(i);
                armaBombList[i]:getAnimation():play("skill2a",-1,0);
                armaBombList[i]:getAnimation():setSpeedScale((1/speedRate));
                armaBombList[i]:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-80)));
                petLayer:addChild(armaBombList[i],3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    armaBombList[i]:setScaleX(armaBombList[i]:getScaleX()*-1);
                end
                bldFuncList[i] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                armaBombList[i]:getAnimation():setMovementEventCallFunc(function(a,b,c)
                    if(b==2)then
                        local tagp = a:getTag();
                        armaBombList[tagp]:removeFromParentAndCleanup(false);                       
                        bldFuncList[tagp]();      
                     end
                end);
    
            end

        elseif(actionJson["sk"]==PET_SK.PET_SK_37)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type1.ExportJson","pet_sk_type1", "petSkillAni/pet_sk_type10.plist");
            arma:getAnimation():play("skill4",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            
            local p ;
            local px = atkPos - atkPos%yPetCnt;
            local py = actionJson["defs"][1]["pos"]%yPetCnt;
            p = px+py;

           -- print("px is ",atkPos,"py ix ",JSON:encode(actionJson));

            arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(240,-90)));

            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(-240,-90)));
                
            end
            --arma:getAnimation():setSpeedScale(0.5);
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(1,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);            
        elseif(actionJson["sk"]==PET_SK.PET_SK_38)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            local yNum = math.floor(actionJson["defs"][1]["pos"]/yPetCnt);

            for i,v in ipairs(actionJson["defs"]) do
                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
            end

            for i=1,yPetCnt do
                
                local tpos = yPetCnt*yNum+i-1;
       
                local arma = createArmatureLua("petSkillAni/pet_sk_type4.ExportJson","pet_sk_type4", "petSkillAni/pet_sk_type40.plist");
                arma:getAnimation():play("skill1",-1,0);
                arma:getAnimation():setSpeedScale((1/speedRate));
                arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(-210,-100)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(210,-100)));
                end
                
                
                --arma:getAnimation():setSpeedScale(0.5);
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   playBeAtkByType(4,actionJson["defs"][idx]["pos"] );
                                   addBldList[idx]();

                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_39)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            for i,v in ipairs(actionJson["defs"]) do
                           
                local arma = createArmatureLua("petSkillAni/pet_sk_type4.ExportJson","pet_sk_type4", "petSkillAni/pet_sk_type40.plist");
                arma:getAnimation():play("skill2",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(-80,-110)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(80,-110)));
                end

                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));

                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   addBldList[idx]();
                                   playBeAtkByType(4,actionJson["defs"][idx]["pos"] );
                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_40)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type4.ExportJson","pet_sk_type4", "petSkillAni/pet_sk_type40.plist");
            arma:getAnimation():play("skill3",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            arma:setPosition(ccpAdd(gCenter,ccp(120,-200)));
            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(gCenter,ccp(-120,-200)));
            end


            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);        
                    playOneStep();
                end
            end);

            local armaBombList = {};
            local bldFuncList = {};
            for i,v in ipairs(actionJson["defs"]) do
                armaBombList[i] = createArmatureLua("petSkillAni/pet_sk_type4.ExportJson","pet_sk_type4", "petSkillAni/pet_sk_type40.plist");
                armaBombList[i]:setTag(i);
                armaBombList[i]:getAnimation():play("skill3a",-1,0);
                armaBombList[i]:getAnimation():setSpeedScale((1/speedRate));
                armaBombList[i]:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-80)));
                petLayer:addChild(armaBombList[i],3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    armaBombList[i]:setScaleX(armaBombList[i]:getScaleX()*-1);
                end
                bldFuncList[i] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                armaBombList[i]:getAnimation():setMovementEventCallFunc(function(a,b,c)
                    if(b==2)then
                        local tagp = a:getTag();
                        armaBombList[tagp]:removeFromParentAndCleanup(false);                       
                        bldFuncList[tagp]();      
                     end
                end);
    
            end

        elseif(actionJson["sk"]==PET_SK.PET_SK_41)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type4.ExportJson","pet_sk_type4", "petSkillAni/pet_sk_type40.plist");
            arma:getAnimation():play("skill4",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            
            local p ;
            local px = atkPos - atkPos%yPetCnt;
            local py = actionJson["defs"][1]["pos"]%yPetCnt;
            p = px+py;

           -- print("px is ",atkPos,"py ix ",JSON:encode(actionJson));

            arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(100,-110)));

            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(-100,-110)));
                
            end
            --arma:getAnimation():setSpeedScale(0.5);
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(4,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);
        elseif(actionJson["sk"]==PET_SK.PET_SK_42)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            local yNum = math.floor(actionJson["defs"][1]["pos"]/yPetCnt);

            for i,v in ipairs(actionJson["defs"]) do
                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
            end

            for i=1,yPetCnt do
                
                local tpos = yPetCnt*yNum+i-1;
       
                local arma = createArmatureLua("petSkillAni/pet_sk_type3.ExportJson","pet_sk_type3", "petSkillAni/pet_sk_type30.plist");
                arma:getAnimation():play("skill1",-1,0);
                arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(-0,-100)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getPosOfPos(tpos),ccp(0,-100)));
                end
                
                
                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));
                if(i==1)then
                    arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                        if(b==2)then
                            armaLayer:removeFromParentAndCleanup(false);
                            for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   playBeAtkByType(3,actionJson["defs"][idx]["pos"] );
                                   addBldList[idx]();

                            end              
                            playOneStep();
                        end
                    end);
                end
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_43)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            print("jaxjax");
            local armaLayer = CCLayer:create();
            local addBldList = {};
            petLayer:addChild(armaLayer,100);
            for i,v in ipairs(actionJson["defs"]) do
                           
                local arma = createArmatureLua("petSkillAni/pet_sk_type3.ExportJson","pet_sk_type3", "petSkillAni/pet_sk_type30.plist");
                arma:getAnimation():play("skill2",-1,0);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-130)));
                armaLayer:addChild(arma,3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    arma:setScaleX(arma:getScaleX()*-1);
                    arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(0,-130)));
                end

                arma:getAnimation():setSpeedScale(0.5*(1/speedRate));




                addBldList[#addBldList+1] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                
                local array = CCArray:create();
                
                array:addObject(CCMoveTo:create(0.3*speedRate,ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-130))));

                if(i==1)then
                    array:addObject(CCCallFunc:create(function()
                        armaLayer:removeFromParentAndCleanup(false);
                        for idx,val in ipairs(addBldList)do
                                   --print("-----heheheh",idx);
                                   addBldList[idx]();
                                   playBeAtkByType(3,actionJson["defs"][idx]["pos"] );
                                   
                        end
                    end));

                    array:addObject(CCCallFunc:create(playOneStep));
                end
                local action = CCSequence:create(array);
                arma:runAction(action);
     
            end
        elseif(actionJson["sk"]==PET_SK.PET_SK_44)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type3.ExportJson","pet_sk_type3", "petSkillAni/pet_sk_type30.plist");
            arma:getAnimation():play("skill3",-1,0);
            arma:getAnimation():setSpeedScale((1/speedRate));
            arma:setPosition(ccpAdd(gCenter,ccp(0,-60)));
            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(gCenter,ccp(-0,-60)));
            end


            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);        
                    playOneStep();
                end
            end);

            local armaBombList = {};
            local bldFuncList = {};
            for i,v in ipairs(actionJson["defs"]) do
                armaBombList[i] = createArmatureLua("petSkillAni/pet_sk_type3.ExportJson","pet_sk_type3", "petSkillAni/pet_sk_type30.plist");
                armaBombList[i]:setTag(i);
                armaBombList[i]:getAnimation():play("skill2a",-1,0);
                armaBombList[i]:getAnimation():setSpeedScale((1/speedRate));
                armaBombList[i]:setPosition(ccpAdd(getPosOfPos(actionJson["defs"][i]["pos"]),ccp(0,-80)));
                petLayer:addChild(armaBombList[i],3);
                if(atkPos>=yPetCnt*xPetCnt) then
                    armaBombList[i]:setScaleX(armaBombList[i]:getScaleX()*-1);
                end
                bldFuncList[i] = getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"]);
                armaBombList[i]:getAnimation():setMovementEventCallFunc(function(a,b,c)
                    if(b==2)then
                        local tagp = a:getTag();
                        armaBombList[tagp]:removeFromParentAndCleanup(false);                       
                        bldFuncList[tagp]();      
                     end
                end);
    
            end

        elseif(actionJson["sk"]==PET_SK.PET_SK_45)then
            playEffect(SK_MUSIC[actionJson["sk"]]);
            local arma = createArmatureLua("petSkillAni/pet_sk_type3.ExportJson","pet_sk_type3", "petSkillAni/pet_sk_type30.plist");
            arma:getAnimation():play("skill4",-1,0);

            
            local p ;
            local px = atkPos - atkPos%yPetCnt;
            local py = actionJson["defs"][1]["pos"]%yPetCnt;
            p = px+py;

           -- print("px is ",atkPos,"py ix ",JSON:encode(actionJson));

            arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(320,-90-20)));

            petLayer:addChild(arma,3);

            if(atkPos>=yPetCnt*xPetCnt) then
                arma:setScaleX(arma:getScaleX()*-1);
                arma:setPosition(ccpAdd(getSkPos(desplayPos),ccp(-320,-90-20)));
                
            end
            arma:getAnimation():setSpeedScale(1/speedRate);
            arma:getAnimation():setMovementEventCallFunc(function(a,b,c)
                if(b==2)then
                    arma:removeFromParentAndCleanup(false);
                    for i,v in ipairs(actionJson["defs"]) do
                        --print("hahahhajax");
                        getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])();
                        playBeAtkByType(3,actionJson["defs"][i]["pos"] );
                    end            
                    playOneStep();
                end
            end);            
        else
            local array = CCArray:create();
            for i,v in ipairs(actionJson["defs"]) do           
                array:addObject(CCCallFunc:create(getAddBldFunc(actionJson["defs"][i]["pos"],actionJson["defs"][i]["bld_add"])));
            end
            array:addObject(CCDelayTime:create(0.5*speedRate));
            array:addObject(CCCallFunc:create(playOneStep));
            local action = CCSequence:create(array);
            petLayer:runAction(action);
        end
    
    end




    if(m_ActionList[curStep]["sk"]~=0)then
        
        CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("petSkillAni/petFightBgAni_new.ExportJson");
	    local fullSkillLayer = CCLayer:create();
	    petLayer:addChild(fullSkillLayer,200);

	    local bgArma = CCArmature:create("petFightBgAni_new");
	    bgArma:getAnimation():play("idle");
	    bgArma:setPosition(ccp(gLeft,gTop));
	    bgArma:getAnimation():setSpeedScale((1/speedRate));


	    petLayer:addChild(bgArma,-1);


	    local bgSprite = CCSprite:create("petSkillAni/bg.png");

	    local size = CCDirector:sharedDirector():getWinSize();
	    bgSprite:setPosition(gCenter);
	    bgSprite:setScaleX(size.width/bgSprite:getContentSize().width);
	    bgSprite:setScaleY(size.height/bgSprite:getContentSize().height);
	    petLayer:addChild(bgSprite,-2);


	    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("petSkillAni/petPhotoAnim.ExportJson");
	    local petPhoto = CCArmature:create("petPhotoAnim");
	    petPhoto:getAnimation():play("skill_idle",-1,0);
        petPhoto:getAnimation():setSpeedScale((1/speedRate));
	    
	    fullSkillLayer:addChild(petPhoto,3);


        local skName = createArmatureLua("petSkillAni/sk_name.ExportJson","sk_name", "petSkillAni/sk_name.plist");
        skName:getAnimation():play("skill-3",-1,0);    
        skName:getAnimation():setSpeedScale((1/speedRate));

        local szImgSkName = string.format("petSkillAni/skn_%d.png",m_ActionList[curStep]["sk"]);
	    
        if(m_ActionList[curStep]["sk"]==PET_SK.ALL_ADD)then
            szImgSkName = string.format("petSkillAni/skn_%d.png",PET_SK.PET_SK_46);
        end
        local sknImg = CCSkin:create(szImgSkName);
        if(sknImg)then
	        sknImg:setAnchorPoint(ccp(0,1));
	        local sknBone = skName:getBone("bone1");
	        sknBone:addDisplay(sknImg,1);
	        sknBone:changeDisplayWithIndex(1,true);


            fullSkillLayer:addChild(skName,3);
        end


        if(m_ActionList[curStep]["atkpos"]>=yPetCnt*xPetCnt)then
            petPhoto:setPosition(ccp(gRight,gCenterY));
            petPhoto:setScaleX(petPhoto:getScaleX() * -1);
            skName:setPosition(ccp(petPhoto:getPositionX()-400,petPhoto:getPositionY()-20));
        else
            petPhoto:setPosition(ccp(gLeft,gCenterY));
            skName:setPosition(ccp(petPhoto:getPositionX()+200,petPhoto:getPositionY()-20));
        end
        skName:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                skName:removeFromParentAndCleanup(false);

            end
        end);


	    petPhoto:getAnimation():setMovementEventCallFunc(function(a,b,c)
            if(b==2)then
                fullSkillLayer:removeFromParentAndCleanup(false);
                bgSprite:removeFromParentAndCleanup(false);
                bgArma:removeFromParentAndCleanup(false);
                showAction();
            end
        end);

        local petId = getDescId(m_ActionList[curStep]["petid"]);
        local szImgName = string.format("goods/item_%d.png",petId)
	    local petImg = CCSkin:create(szImgName);
	    petImg:setAnchorPoint(ccp(0,1));
	    local petBone = petPhoto:getBone("1");
	    petBone:addDisplay(petImg,1);
	    petBone:changeDisplayWithIndex(1,true);


    else
        showAction();
    end
    
end

local function playFightList(petFightList)
    local cache = CCSpriteFrameCache:sharedSpriteFrameCache();
    cache:addSpriteFramesWithFile("petFight/petFightAni.plist");
    cache:addSpriteFramesWithFile("petSkillAni/petFightBgAni_new0.plist");
    cache:addSpriteFramesWithFile("petSkillAni/petPhotoAnim0.plist");
    cache:addSpriteFramesWithFile("link/pet_attack_1.plist");
    cache:addSpriteFramesWithFile("link/gameresult.plist");
    cache:addSpriteFramesWithFile("link/pet_attack_2.plist");
    cache:addSpriteFramesWithFile("link/pet_attack_3.plist");
    cache:addSpriteFramesWithFile("link/pet_attack_4.plist");
    cache:addSpriteFramesWithFile("link/pet_attack_5.plist");
    curStep =1;
    m_ActionList= petFightList;
    playOneStep();

end



local function initPet()
    print("init pet");
    --local map = getUserInfo("map");
    --local map2 = getUserInfo("map");
    local petInMap2 = enemyMap["pet"]["growpet"];
    local petInMap = myMap["pet"]["growpet"];

    if(not petInMap) then
        petInMap = {};
    end
    if(not petInMap2) then
        petInMap2 = {};
    end

  --  logJson(petInMap);
    local pos = {0,1,2,3,4,5,6,7,8};
    petStats = {};

    for idx ,var in ipairs(petInMap) do
        local petBg ;
        local petId = getDescId(var["id"]);
        if(petAniConf[tostring(petId)]) then
            local petAni = CCAnimation:create();
            petBg = CCSprite:create();
            local imgList = spiltArray(petAniConf[tostring(petId)]["nor_list"],".");
            for idx,var in ipairs(imgList) do            
                local imgName = string.format("petSkill/%d/%s.png",petId,var);
                petAni:addSpriteFrameWithFileName(imgName);
            end
            petAni:setDelayPerUnit(petAniConf[tostring(petId)]["atk_inv"]*2*speedRate);
            --petAni:setLoops(-1);
            local atkAct = CCAnimate:create(petAni);
            petBg:setScale(petScaleConf);
            petBg:runAction(CCRepeatForever:create(atkAct));
            petBg:setFlipX(false);
        else
            petBg = getGoodsRes(petId,0);
            petBg:setScale(0.5*petScaleConf);
            petBg:setFlipX(true);
        end
        --petBg:setVisible(false);
        if(not var["pos"])then
            local idx = math.random(1,#pos);
            var["pos"] = pos[idx];
            table.remove(pos,idx);
        end

        if(not var["lv"])then
            var["lv"] = 10;
        end
        print("time to begin gb1",os.clock());
        local bld = getPetBlood(var);
       -- bld = 100000;
        print("time to begin gb2",os.clock());
        var["bld_sum"] = bld;
        var["bld_cur"] = bld;

        local nameNode = CCNode:create();
        

        local nameBg = CCSprite:create("petFight/nameBg.png");
        nameBg:setPosition(ccp(0,60));
        nameNode:addChild(nameBg,0);
        
        local lv = CCLabelAtlas:create(tostring(var["lv"]),"common/lvNum.png",14,21,48);
        lv:setAnchorPoint(ccp(0.5,0.5));
        lv:setPosition(ccp( -55,60));
        nameNode:addChild(lv,1);

        local lvBg = CCSprite:create("petFight/lvBg.png");
        lvBg:setPosition(ccp(lv:getPositionX(),lv:getPositionY()));
        nameNode:addChild(lvBg,0);


        local namestr = CUserData:getInstance():getGoodsNameById(var["id"]);

        if(var["g"])then
           namestr = namestr .."+"..var["g"];
        end

        local nameLabel = CCLabelTTF:create(namestr,MWLL_FONT_NAME,20);
        nameLabel:setPosition(ccp(10,60));
        nameLabel:setColor(getColorById(var["id"]));
        nameNode:addChild(nameLabel,3);


		local pBldSlider = CCControlSlider:create("hp_bg.png", "hp_progress3.png", "transparent.png");
        pBldSlider:setMinimumValue(0.0) ;
        pBldSlider:setMaximumValue(bld) ;
		pBldSlider:setValue(bld);
        pBldSlider:setPosition(ccp(0,35));
        pBldSlider:setScale(0.4);
        nameNode:addChild(pBldSlider,2);
        
        print("time to begin gc1",os.clock());
        local oneConf = getPetConfById(var["id"]);
        local petType = oneConf["type"];
        
        print("time to begin gc2",os.clock());

        local p = getPosOfPos(var["pos"]);
        if(petPosConf[tostring(petId)])then
            petBg:setPosition(ccpAdd(p,ccp(petPosConf[tostring(petId)]["coordinateX"],petPosConf[tostring(petId)]["coordinateY"])));
            petBg:setScale(petBg:getScale()*petPosConf[tostring(petId)]["coefficient"]);
        else
            petBg:setPosition(p);
        end

        
        petLayer:addChild(petBg,2,petId);

        petLayer:addChild(nameNode,3);
        nameNode:setPosition(ccp(p.x,p.y+50));

        
        local star = getPetConfById(var["id"])["q"] or 1;
        local szTmp = string.format("common/pet_bg_%d.png",star);
        local petFoot = CCSprite:create(szTmp);
        petFoot:setPosition(ccp(p.x,p.y- 85));
        --petFoot:setScale(2.0);
        petLayer:addChild(petFoot,1);

        
        var["rage"] = 0;
  --      local pRageSlider = CCControlSlider:create("hp_bg.png", "hp_progress4.png", "transparent.png");
  --      pRageSlider:setMinimumValue(0.0) ;
  --      pRageSlider:setMaximumValue(rageSum) ;
		--pRageSlider:setValue(var["rage"]);
  --      pRageSlider:setPosition(ccp(0,20));
  --      pRageSlider:setScale(0.4);
  --      nameNode:addChild(pRageSlider,2);

        local pRageSlider = CCLabelTTF:create("0",MWLL_FONT_NAME,18);
        pRageSlider:setPosition(ccp(-55,35));
        nameNode:addChild(pRageSlider,4);

        local pRageBgSp = CCSprite:create("petFight/rageBg.png");
        local pRageBg = CCProgressTimer:create(pRageBgSp);
        pRageBg:setAnchorPoint(ccp(0.5,0.5));
        pRageBg:setType(kCCProgressTimerTypeRadial);
        pRageBg:setPercentage(0);
        pRageBg:setPosition(pRageSlider:getPosition());
        nameNode:addChild(pRageBg,3);

        local pRagebbg = CCSprite:create("petFight/rageBg0.png");
        pRagebbg:setPosition(pRageSlider:getPosition());
        nameNode:addChild(pRagebbg,2);

        s = {["ragebbg"]=pRagebbg,["rageSld"] =pRageSlider ,["rageBg"]=pRageBg ,["bld"]=bld,["sprite"]=petBg,["bldSld"]=pBldSlider,["type"]=petType,["bld_max"]=bld,["foot"]=petFoot,["namenode"] = nameNode};
        petStats[var["pos"]] = s;
    end

    myPet ={};
    myPet = petInMap;

   

    pos = {0,1,2,3,4,5,6,7,8};
    for idxx ,var in ipairs(petInMap2) do
        local petBg ;
        local petId = getDescId(var["id"]);
        if(petAniConf[tostring(petId)]) then
            local petAni = CCAnimation:create();
            petBg = CCSprite:create();

            local imgList = spiltArray(petAniConf[tostring(petId)]["nor_list"],".");
            for idx,var in ipairs(imgList) do            
                local imgName = string.format("petSkill/%d/%s.png",petId,var);
                petAni:addSpriteFrameWithFileName(imgName);
            end
            petAni:setDelayPerUnit(petAniConf[tostring(petId)]["atk_inv"]*2*speedRate);
            --petAni:setLoops(-1);
            local atkAct = CCAnimate:create(petAni);
            petBg:setScale(petScaleConf);
            petBg:runAction(CCRepeatForever:create(atkAct));
            petBg:setFlipX(true);
        else
            petBg = getGoodsRes(petId,0);
            petBg:setScale(0.5*petScaleConf);
            petBg:setFlipX(false);
        end
        
        if(not var["pos"])then
            local idx = math.random(1,#pos);
            var["pos"] = pos[idx];
            table.remove(pos,idx);
        end

        if(not var["lv"])then
            var["lv"] = 10;
        end
        print("time to begin gb1",os.clock());
        local bld = getPetBlood(var);
        --bld = 1;
        print("time to begin gb2",os.clock());
        var["bld_sum"] = bld;
        var["bld_cur"] = bld;

        local nameNode = CCNode:create();
        

        local nameBg = CCSprite:create("petFight/nameBg.png");
        nameBg:setPosition(ccp(0,60));
        nameNode:addChild(nameBg,0);
        
        local lv = CCLabelAtlas:create(tostring(var["lv"]),"common/lvNum.png",14,21,48);
        lv:setAnchorPoint(ccp(0.5,0.5));
        lv:setPosition(ccp( -55,60));
        nameNode:addChild(lv,1);

        local lvBg = CCSprite:create("petFight/lvBg.png");
        lvBg:setPosition(ccp(lv:getPositionX(),lv:getPositionY()));
        nameNode:addChild(lvBg,0);


        local namestr = CUserData:getInstance():getGoodsNameById(var["id"]);

        if(var["g"])then
           namestr = namestr .."+"..var["g"];
        end

        local nameLabel = CCLabelTTF:create(namestr,MWLL_FONT_NAME,20);
        nameLabel:setPosition(ccp(10,60));
        nameLabel:setColor(getColorById(var["id"]));
        nameNode:addChild(nameLabel,3);


		local pBldSlider = CCControlSlider:create("hp_bg.png", "hp_progress3.png", "transparent.png");
        pBldSlider:setMinimumValue(0.0) ;
        pBldSlider:setMaximumValue(bld) ;
		pBldSlider:setValue(bld);
        pBldSlider:setPosition(ccp(0,35));
        pBldSlider:setScale(0.4);
        nameNode:addChild(pBldSlider,2);
        


        print("time to begin gc1",os.clock());
        local oneConf = getPetConfById(var["id"]);
        local petType = oneConf["type"];
        
        print("time to begin gc2",os.clock());

        local p = getPosOfPos(var["pos"]+yPetCnt*xPetCnt);
        if(petPosConf[tostring(petId)])then
            petBg:setPosition(ccpAdd(p,ccp(-petPosConf[tostring(petId)]["coordinateX"],petPosConf[tostring(petId)]["coordinateY"])));
            petBg:setScale(petBg:getScale()*petPosConf[tostring(petId)]["coefficient"]);
        else
            petBg:setPosition(p);
        end
        petLayer:addChild(petBg,2,petId);

        petLayer:addChild(nameNode,3);
        nameNode:setPosition(p.x,p.y+50);

        local star = getPetConfById(var["id"])["q"] or 1;
        local szTmp = string.format("common/pet_bg_%d.png",star);
        local petFoot = CCSprite:create(szTmp);
        petFoot:setFlipX(true);
        petFoot:setPosition(ccp(p.x,p.y- 85));
        --petFoot:setScale(2.0);
        petLayer:addChild(petFoot,1);

        var["rage"] = 0;
  --      local pRageSlider = CCControlSlider:create("hp_bg.png", "hp_progress4.png", "transparent.png");
  --      pRageSlider:setMinimumValue(0.0) ;
  --      pRageSlider:setMaximumValue(rageSum) ;
		--pRageSlider:setValue(var["rage"]);
  --      pRageSlider:setPosition(ccp(0,20));
  --      pRageSlider:setScale(0.4);
  --      nameNode:addChild(pRageSlider,2);

        local pRageSlider = CCLabelTTF:create("0",MWLL_FONT_NAME,18);
        pRageSlider:setPosition(ccp(-55,35));
        nameNode:addChild(pRageSlider,4);

        local pRageBgSp = CCSprite:create("petFight/rageBg.png");
        local pRageBg = CCProgressTimer:create(pRageBgSp);
        pRageBg:setAnchorPoint(ccp(0.5,0.5));
        pRageBg:setType(kCCProgressTimerTypeRadial);
        pRageBg:setPercentage(0);
        pRageBg:setPosition(pRageSlider:getPosition());
        nameNode:addChild(pRageBg,3);

        local pRagebbg = CCSprite:create("petFight/rageBg0.png");
        pRagebbg:setPosition(pRageSlider:getPosition());
        nameNode:addChild(pRagebbg,2);


        s = {["ragebbg"]=pRagebbg,["rageSld"] =pRageSlider,["rageBg"]=pRageBg ,["bld"]=bld,["sprite"]=petBg,["bldSld"]=pBldSlider,["type"]=petType,["bld_max"]=bld,["foot"]=petFoot,["namenode"] = nameNode};
        petStats[var["pos"]+xPetCnt*yPetCnt] = s;

    end

    enemyPet = {};
    enemyPet = petInMap2;

    local petFightList;
    print("time to begin 5",os.clock());
    petFightList,gameResult = getFightList(myPet,enemyPet);
    print("time to begin 6",os.clock());
    playFightList(petFightList);
    print("time to begin 7",os.clock());
end

function showPlayer()
    


    local cache =CCSpriteFrameCache:sharedSpriteFrameCache();
    cache:addSpriteFramesWithFile("link/link_ani.plist");


    local leftNameBg = CCSprite:create("newMenu/expProBg.png");
    bgLayer:addChild(leftNameBg,1);
    leftNameBg:setPosition(ccp(gLeft+leftNameBg:getContentSize().width*0.5,gTop -leftNameBg:getContentSize().height*0.5 -10 ));

    local player_left;
    --local sexImg = string.format("hero_normal_%d.png",myAttr["sex"]);
    player_left =createRoleWithWing(myAttr["sex"],myMap["pet"]["winglevel"] or 1,0.35,true,false);-- CCSprite:createWithSpriteFrameName(sexImg);
    bgLayer:addChild(player_left,2);
    player_left:setPosition(ccp(gLeft+40+player_left:getContentSize().width*0.5,leftNameBg:getPositionY() - 110));

    local leftName = CCLabelTTF:create(myAttr["aname"],MWLL_FONT_NAME,20);
    bgLayer:addChild(leftName,2);
    leftName:setAnchorPoint(ccp(0.0,0.5));
    leftName:setPosition(ccp(leftNameBg:getPositionX(),leftNameBg:getPositionY()));

    local leftLv = createCommLv(myAttr["level"]);
    bgLayer:addChild(leftLv,2);
    leftLv:setAnchorPoint(ccp(0.0,0.5));
    leftLv:setPosition(ccp(leftNameBg:getPositionX()-80,leftNameBg:getPositionY()));

    local lpetFoot = CCSprite:create("petFight/petFoot.png");
    lpetFoot:setPosition(ccp(player_left:getPositionX()+5,player_left:getPositionY()-85));
    bgLayer:addChild(lpetFoot,1);

    --右边
    local rightNameBg = CCSprite:create("newMenu/expProBg.png");
    bgLayer:addChild(rightNameBg,1);
    rightNameBg:setPosition(ccp(gRight - rightNameBg:getContentSize().width*0.5,gTop -rightNameBg:getContentSize().height*0.5 -10 ));

    local player_right;
    if(mid)then
         local mosImg = string.format("monster/%d.png",mid);
         print("mosimg ", mosImg);
        player_right = CCSprite:create(mosImg);
        
    else
        --local sexImg = string.format("hero_normal_%d.png",enemyAttr["sex"]);
        player_right =createRoleWithWing(enemyAttr["sex"],enemyMap["pet"]["winglevel"] or 1,0.35,true,true);-- CCSprite:createWithSpriteFrameName(sexImg);
        --player_right:setFlipX(true);
    end
    bgLayer:addChild(player_right,2);
    player_right:setPosition(ccp(gRight -40- player_right:getContentSize().width*0.5,rightNameBg:getPositionY() - 110));

    local rpetFoot = CCSprite:create("petFight/petFoot.png");
    rpetFoot:setPosition(ccp(player_right:getPositionX(),player_right:getPositionY()-85));
    bgLayer:addChild(rpetFoot,1);

    local rNameStr = enemyAttr["aname"];

    local rightName = CCLabelTTF:create(rNameStr,MWLL_FONT_NAME,20);
    bgLayer:addChild(rightName,2);
    rightName:setAnchorPoint(ccp(0.0,0.5));
    rightName:setPosition(ccp(rightNameBg:getPositionX(),rightNameBg:getPositionY()));

    local rightLv = createCommLv(enemyAttr["level"]);
    bgLayer:addChild(rightLv,2);
    rightLv:setAnchorPoint(ccp(0.0,0.5));
    rightLv:setPosition(ccp(rightNameBg:getPositionX()-80,rightNameBg:getPositionY()));

    pPetInCage = nil;
	if (mid and myMap["1"]["game"] and myMap["1"]["game"]["savepet"] )then


		local sc = 0.5;
		local pid = myMap["1"]["game"]["savepet"]["id"];
--		pid = 5001;
		pPetInCage = getGoodsRes(pid,0);
		bgLayer:addChild(pPetInCage);
		pPetInCage:setPosition(ccp(player_right:getPositionX() - 200 ,player_right:getPositionY()+ 0));
		pPetInCage:setScale(sc);

		local pCage = CCSprite:create("link/cage.png");
		pPetInCage:addChild(pCage,1,10);
		pCage:setPosition(ccp(pPetInCage:getContentSize().width*0.5,pPetInCage:getContentSize().width*0.5+35));
		pCage:setScale(1/sc);
		

	end

end

function showAfterDialogCallBack()

    if(pPetInCage)then
	
		pPetInCage:setPosition(gCenter);


		pPetInCage:setFlipX(true);
		pPetInCage:removeAllChildrenWithCleanup(true);
		local cf = CCCallFunc:create(closeBtn);

        local array = CCArray:create();
        array:addObject(CCScaleTo:create(1.0*speedRate,1.2));
        array:addObject(CCDelayTime:create(1.0*speedRate));
        array:addObject(cf);

		pPetInCage:runAction(CCSequence:create(array));

	
	else
	
		closeBtn();
	end

end

function showAfterDialog()
    local conf = getConf("config/main_quest2.txt");
    if(conf["fbstory"][tostring(DialogId)] and conf["fbstory"][tostring(DialogId)]["4"])then
        local infos = {};
        for i,var in ipairs(conf["fbstory"][tostring(DialogId)]["4"]) do
            
            local one ={};
            one["desc"] = var["line"];
            one["name"] = var["name"];
            if(var["typeid"]==0)then
                if(var["npcid"]==0)then
                    if(myAttr["sex"]==1)then
                        one["img"] = "new_quest/new_npc0_1.png";
                    else 
                        one["img"] = "new_quest/new_npc0_2.png";
                    end
                    one["name"] = myAttr["aname"];
                    one["pos"] =0;
                elseif(var["npcid"]==1)then
                    one["img"] = "new_quest/new_npc"..var["npcid"]..".png";
                    one["pos"] =1;
                else
                    one["img"] = "goods/item_"..var["npcid"]..".png";
                    one["pos"] =1;
                end
            else
                one["img"] = "monster/"..var["npcid"]..".png";
                one["pos"] =1;
            end
            
            if(var["size"])then
                one["imgScale"] = var["size"];
            end

            infos[#infos+1] = one;
        end
        if(#infos>0)then
            DialogLayer:getInstance():luaShow(JSON:encode(infos),showAfterDialogCallBack);
        else
            showAfterDialogCallBack();
        end
    else
        showAfterDialogCallBack();
    end
end

function showBeforeDialogCallBack()
    print("time to begin 3",os.clock());
    showPlayer();
     print("time to begin 4",os.clock());
    initPet();
     print("time to begin 10",os.clock());
end

function showBeforeDialog()
    local conf = getConf("config/main_quest2.txt");
    if(conf["fbstory"][tostring(DialogId)] and conf["fbstory"][tostring(DialogId)]["3"])then
        local infos = {};
        for i,var in ipairs(conf["fbstory"][tostring(DialogId)]["3"]) do
            
            local one ={};
            one["desc"] = var["line"];
            one["name"] = var["name"];
            if(var["typeid"]==0)then
                if(var["npcid"]==0)then
                    if(myAttr["sex"]==1)then
                        one["img"] = "new_quest/new_npc0_1.png";
                    else 
                        one["img"] = "new_quest/new_npc0_2.png";
                    end
                    one["name"] = myAttr["aname"];
                    one["pos"] =0;
                elseif(var["npcid"]==1)then
                    one["img"] = "new_quest/new_npc"..var["npcid"]..".png";
                    one["pos"] =1;
                else
                    one["img"] = "goods/item_"..var["npcid"]..".png";
                    one["pos"] =1;
                end
            else
                one["img"] = "monster/"..var["npcid"]..".png";
                one["pos"] =1;
            end
            
            if(var["size"])then
                one["imgScale"] = var["size"];
            end

            infos[#infos+1] = one;
        end
        if(#infos>0)then
            DialogLayer:getInstance():luaShow(JSON:encode(infos),showBeforeDialogCallBack);
        else
            showBeforeDialogCallBack();
        end
    else
        showBeforeDialogCallBack();
    end

end

local function speedUp()
    if speedStat~=0 then
        if myAttr["vip"] > 2 then
            if btnSpeed then
		        btnSpeed:setSelectedIndex(1);
	        end
        end
    end
end

local function speedDown()
    if speedStat == 0 then
	    if btnSpeed then
		    btnSpeed:setSelectedIndex(0);
	    end
    end
end

local function saveSpeedStatLocal()
    local key = CUserData:getInstance():getUid() .. "_speed_stat_petfight";
    CCUserDefault:sharedUserDefault():setIntegerForKey(key,speedStat);
    CCUserDefault:sharedUserDefault():flush();
end

local function getSpeedFromLocal()
    local key = CUserData:getInstance():getUid() .. "_speed_stat_petfight";
    return CCUserDefault:sharedUserDefault():getIntegerForKey(key);
end

local function initVipSpeed(stat)--参数nil的时候从本地初始化，非nil的时候更新本地状态
    speedStat = stat;
    if(stat) then
    --print("*****************speedStat" .. stat);
    end
    local vipConf = getConf("config/newvip_config.txt");
	local vipLvl = myAttr["vip"] == nil or myAttr["vip"];
    --print("**********vipLvl"..vipLvl);
    --print("******vipConf[function][vipLvl]******"..vipConf["function"][""..vipLvl]);
    --print("*****vipConf[function][vipLvl][10]*******"..vipConf["function"][""..vipLvl][10]);
	--是否有权限开启加速
	local isEnableSpeed = false;

	if(vipLvl~=nil and vipLvl > 2 and vipConf["fun_map"][""..vipLvl]["fbjs"]~=nil ) then --会员而且开启了加速特权
		---print("****************1");
        --print("*****************name:" .. vipConf["function"][""..vipLvl][11]["name"]);
        --if("fbjs" == vipConf["fun_map"][""..vipLvl][]["name"]) then
            --print("****************2");
			if(vipConf["fun_map"][""..vipLvl]["fbjs"]["count"] == 1) then
                --print("****************3");
				isEnableSpeed = true;
			end
		--end
	end
    if(isEnableSpeed)then
        --print("*****************isEnableSpeed true");
    else
        --print("*****************isEnableSpeed false");
    end
    
    if(isEnableSpeed)then
		if(stat == nil)then--从本地存储初始化
			--配置里是否开启vip加速特权
			speedStat = getSpeedFromLocal();
		else--更新加速状态到本地
			saveSpeedStatLocal();
        end
	else
		speedStat = 0;
		saveSpeedStatLocal();
	end
    --print("*****************speedStat" .. speedStat);
    --开启了加速特权
	if(speedStat > 0) then
		if(vipConf["speed"] and vipConf["speed"][""..vipLvl]) then
			speedRate = 1 / vipConf["speed"][""..vipLvl]["jssp"];
		--配置里面没有配置相应vip的加速特权
		else
			speedStat = 0;
            speedRate = 1.0;
			saveSpeedStatLocal();
        end
	else--没有开启加速
		speedRate = 1.0;
    end
    --print("************speedRate" .. speedRate);
end

local function updateBtnSpeed()
    initVipSpeed();
	--启动自动战斗
	if speedStat~=0 then
        --print("*********speedUp");
		speedUp();
	else
		speedDown();
	end
end

local function MenuCallback_ClickBtnSpeed()
	--当前是自动战斗状态,所以这里应该是切换至取消自动战斗状态
	if speedStat == 1 then
		initVipSpeed(0);--取消加速
		speedDown();
	--当前是非自动战斗状态,所以这里应该是切换至自动战斗状态
	else
		--不是会员
		if myAttr["vip"] == nil or myAttr["vip"] <= 2 then
             initVipSpeed(0);
             speedDown();
             CAlertLayer:getInstance():showAlert(this,"激活VIP3可开启");
			 return;
        end
		initVipSpeed(1);
		speedUp();
    end
end

function createFightLayer(parent,info,ftype,callback)
    print("time to begin",os.clock());
    parentLayer = parent;
    petConf = getConf("config/growpet_config.txt");
    petAniConf = getConf("petSkill/pet_ani_conf.txt");
    petPosConf = getConf("config/fightPosition_config.txt");
    luaCallBack = callback;

  --  print("info is ",info);
    local infoJson = JSON:decode(info);

    myMap = infoJson["self"]["map"];
    myAttr = infoJson["self"]["attr"];

    enemyMap = infoJson["enemy"]["map"];
    enemyAttr = infoJson["enemy"]["attr"];

    speedStat = getSpeedFromLocal(myAttr);

    if(myAttr["sex"]~=2 and myAttr["sex"]~=1) then
        myAttr["sex"] =1;
    end

    if(enemyAttr["sex"]~=2 and enemyAttr["sex"]~=1) then
        enemyAttr["sex"] =1;
    end

    playBGM(BG_MUSIC.BACKGROUND_MUSIC_PVE_BGM);
    mid = infoJson["enemy"]["mid"];
    --myMap = getUserInfo("map");
    --myAttr = getUserInfo("attr");

    --if(myMap["1"]["game"]["npcinfo"]["boss"]["leadfight"]>myMap["pet"]["zdl"]["zdl_sum"])then
    --    myMul = myMap["1"]["game"]["npcinfo"]["boss"]["playeratk"];
    --    enemyMul = myMap["1"]["game"]["npcinfo"]["boss"]["npcatk"]
    --end

    myMul = infoJson["self"]["atk_mul"] or 1.0;
    enemyMul = infoJson["enemy"]["atk_mul"] or 1.0;
    print("mymul ",myMul,"enemymul ",enemyMul);

    CCSpriteFrameCache:sharedSpriteFrameCache():removeUnusedSpriteFrames();
	--CCTextureCache:sharedTextureCache():removeUnusedTextures();
    
    fightLayer = CCLayer:create();
    parent:addChild(fightLayer,300); 
    
    winSize = CCDirector:sharedDirector():getWinSize();

    bgLayer = CCLayer:create();
    fightLayer:addChild(bgLayer,-10);

    petLayer = CCLayer:create();
    fightLayer:addChild(petLayer,2);


    local bgImg;
    if(infoJson["bgid"])then
    
        bgImg = "petFight/petFightBg"..infoJson["bgid"]..".jpg";
    
    else
    
        bgImg = "petFight/petFightBg"..math.random(1,4)..".jpg";
    end


    local bgSprite = CCSprite:create(bgImg);
    bgSprite:setPosition(ccp(winSize.width/2,winSize.height/2));
    bgLayer:addChild(bgSprite);
    
    if(winSize.width/bgSprite:getContentSize().width > winSize.height/bgSprite:getContentSize().height)then
        bgSprite:setScale(winSize.width/bgSprite:getContentSize().width);
    else
        bgSprite:setScale(winSize.height/bgSprite:getContentSize().height);
    end




   -- 
   -- fightLayer:setTouchPriority(-100000);
    fightLayer:registerScriptTouchHandler(fightLayerOnTouch,false,int_min+1,true);
    fightLayer:setTouchEnabled(true);
   -- fightLayer:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(20),CCCallFunc:create(closeBtn)));
     
    --自动战斗
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("link/autofight.plist");
	local pAuto=CCSprite:createWithSpriteFrameName("autofightui000.png");
	local ifps=12;
	local pAutoFonts=CCAnimate:create(createAnimate("autofightui%03d.png",10,ifps,0,false));
	pAuto:runAction(CCRepeatForever:create(pAutoFonts));
	local fy=80;
    pAuto:setPosition(ccp(winSize.width/2,winSize.height - fy));
    fightLayer:addChild(pAuto,3);

    --自动战斗旁边有一个加速按钮
    local pBtnSpeed = CCMenuItemImage:create("petFight/btn_speed_n.png","petFight/btn_speed_s.png","petFight/btn_speed_s.png");
	local pBtnNotSpeed = CCMenuItemImage:create("petFight/btn_not_speed_n.png","petFight/btn_not_speed_s.png","petFight/btn_not_speed_s.png");
    btnSpeed = CCMenuItemToggle:create(pBtnSpeed);
    btnSpeed:addSubItem(pBtnNotSpeed);
    btnSpeed:setPosition(ccp(pAuto:getPositionX()+290,pAuto:getPositionY()));
    btnSpeed:registerScriptTapHandler(MenuCallback_ClickBtnSpeed);
    updateBtnSpeed();
    
    local pCloseBtn = CCMenuItemImage:create("commBg/back.png","commBg/back.png");
    pCloseBtn:setPosition(ccp(100+pCloseBtn:getContentSize().width/2,winSize.height-pCloseBtn:getContentSize().height/2 ));

    local pMenu = CCMenu:create();
    fightLayer:addChild(pMenu,3);
    pMenu:setPosition(ccp(0,0));
--  pMenu:addChild(pCloseBtn);
    pMenu:addChild(btnSpeed);
    btnSpeed:setTag(12345);

    pMenu:setTouchPriority(int_min);
    pCloseBtn:registerScriptTapHandler(closeBtn);
    print("time to begin 2",os.clock());
    local jid = CUserData:getInstance().m_iJumpQid;
    if(jid~=0)then
        print("jump id is ",jid);
        local qConf = getConf("config/main_quest2.txt");
        local jqConf;
        local mbConf = getConf("config/mobileConf.txt");
        local qClass = mbConf["petPveQclass"];
        for i,var in ipairs(qConf["quest"])do
            if(var["id"]==jid and var["qclass"] == qClass)then
                DialogId = var["tid"];
                break;
            end
        end
        if(DialogId)then
            showBeforeDialog();
         else
            showBeforeDialogCallBack();
        end
    else
        showBeforeDialogCallBack();
    end

    return fightLayer;
end

--endregion
